      SUBROUTINE LOWDIN
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (MXIODA=255)
      PARAMETER (MXBFN=3072)
      PARAMETER (MXATOM=128)
      CHARACTER*8 ERRMSG
      REAL*8  MP2
      LOGICAL LAST
      LOGICAL OUT,POPOUT
      COMMON/IOFILE/IR,IW,IP
      COMMON/DAFILE/IDAF,NAV,IODA(MXIODA)
      COMMON/MEMORY/MAXCOR,MAXLCM
      COMMON/OUTPUT/NPRINT
      COMMON/WFNOPT/WFNTYP
      COMMON/SCFOPT/SCFTYP
      COMMON/PRPOPT/NOPROP
      COMMON/RUNOPT/RUNTYP
      COMMON/BASSPH/ISPHER
      COMMON/MOLSPH/SPHLAB(MXBFN)
      COMMON/MOLLAB/ANAM(MXATOM),BNAM(MXATOM),BFLAB(MXBFN)
      COMMON/INFOA/NAT,ICH,MUL,NUM,NX,NE,NA,NB,ZAN(MXATOM),
     1                                         C(3,MXATOM)
      COMMON/MOLNUC/NUC(MXATOM)
      COMMON/MLKPOP/POPMLK(MXATOM),CHGMLK(MXATOM),SPNMLK(MXATOM)
      COMMON/BFNATM/LIMLOW(MXATOM),LIMSUP(MXATOM)
      COMMON/IJPAIR/IA(1)
      COMMON/SCM/X(1)
      DIMENSION ZNUC(MXATOM)
      DIMENSION ERRMSG(3)
      DATA ERRMSG         /'PROGRAM ','STOP IN ','-LOWDIN-'/
      DATA ALPHA,BETA,ALL /'   ALPHA','    BETA','     ALL'/
      DATA SCF,UHF        /'SCF     ','UHF     '/
      DATA MP2            /'MP2     '/
      DATA PROP           /'PROPTY  '/
      DATA ZERO           /0.0D+00/
      DATA NORB           /0/
      DATA MOFLG          /0/
C
      L1= NUM
      L2=(NUM*(NUM+1))/2
      L3= NUM*NUM
C
C     ----- SET POINTERS FOR PARTITIONING OF CORE -----
C
      I00=     1
      I01=I00+L3
      I10=I01+L1
      I20=I10+L2
C
      I30=I20
      I40=I30+(NAT*(NAT+1))/2
      I50=I40+L2
      I60=I50+L1
      I70=I60+NAT
C
      I41=I70
      I51=I41+L2
      I61=I51+L1
      I71=I61+NAT
C
      I42=I71+L3
      I52=I42+L1
C
      I53=I52+L3
      I63=I53+NAT*NAT
      I73=I63+NAT
      I83=I73+NAT
      I93=I83+L3
      I94=I93+NAT
      I95=I94+NAT
C
C     ----- GET CORE MEMORY -----
C
      CALL CMEM(LOADCM)
      LASTX=I95
      LASTX=LASTX-1
      LOC10=LOCCM(X(I10))
      NEED =LOC10+LASTX
      IF(NEED.GT.MAXCOR) THEN
         WRITE(IW,9991)
         CALL NEEDCM(LASTX,NEED)
         RETURN
      ENDIF
C
      DO IAT=1,NAT
         ZNUC(IAT)=NUC(IAT)
      ENDDO
C
C     ----- DETERMINE NUMBER OF BASIS FUNCTIONS PER ATOM -----
C
      CALL ATMBFN
C
C     -----         READ IN OVERLAP MATRIX              -----
C     ----- TRANSFORM TO SPHERICAL HARMONICS IF NEEDED  -----
C
C     -SPH- AT X(I00)
C     -  S- AT X(I10)
C
      IF(ISPHER.GE.0) THEN
         IF(POPOUT) THEN
            CALL SPHPRT
         ENDIF
         IFINV=1
         IFTSP=0
         CALL SPHMAT(X(I00),L1,IFINV,IFTSP)
         CALL DAREAD(IDAF,IODA,X(I40),L2,12)
         IF(OUT) THEN
            WRITE(IW,9989)
            CALL PRTR(X(I40),L1)
         ENDIF
         CALL TFTR(X(I10),X(I40),X(I00),X(I50),IA,L1,L1,L1)
         IF(OUT) THEN
            WRITE(IW,9986)
            CALL PRTR(X(I10),L1)
         ENDIF
      ELSE
         CALL DAREAD(IDAF,IODA,X(I10),L2,12)
         IF(OUT) THEN
            WRITE(IW,9989)
            CALL PRTR(X(I10),L1)
         ENDIF
      ENDIF
C
C     ----- CALCULATE POPULATION FOR INDIVIDUAL ORBITALS -----
C     ----- TRANSFORM TO SPHERICAL HARMONICS IF NEEDED   -----
C
C     -SPH**(-1)- AT X(I00)
C            -S - AT X(I10)
C
*     IF(ISPHER.GE.0) THEN
*        IFINV=-1
*        IFTSP= 0
*        CALL SPHMAT(X(I00),L1,IFINV,IFTSP)
*     ENDIF
*     IF(POPOUT) THEN
*        CALL ORBPOP(X(I10),X(I40),X(I42),
*    1               IA,NORB,L1,L1,MOFLG,X(I00))
*     ENDIF
C
*     IF(RUNTYP.EQ.PROP) GO TO 1000
C
C     -----            READ DENSITY MATRICES           -----
C     ----- TRANSFORM TO SPHERICAL HARMONICS IF NEEDED -----
C
C     -SPH**(-1)(T)- AT X(I00)
C               -DA- AT X(I40)
C               -DB- AT X(I41)
C
      IF(ISPHER.GE.0) THEN
         IFINV=-1
         IFTSP= 1
         CALL SPHMAT(X(I00),L1,IFINV,IFTSP)
         CALL PRPDEN(X(I41),X(I52),L2)
         CALL TFTR(X(I40),X(I41),X(I00),X(I50),IA,L1,L1,L1) 
         IF((WFNTYP.EQ.SCF.AND.SCFTYP.EQ.UHF).OR.
     1      (WFNTYP.EQ.MP2.AND.SCFTYP.EQ.UHF)    ) THEN
            CALL TFTR(X(I41),X(I52),X(I00),X(I50),IA,L1,L1,L1)
         ENDIF
      ELSE
         CALL PRPDEN(X(I40),X(I41),L2)
      ENDIF
      IPASS=1
      IDEN=I40
      IGOC=I50
      IGAC=I60
      LAST=.FALSE.
      ELEC=ALPHA
      IF((WFNTYP.NE.SCF.OR.SCFTYP.NE.UHF).AND.
     1   (WFNTYP.NE.MP2.OR.SCFTYP.NE.UHF)     ) ELEC=ALL
  100 CONTINUE
C
C     ----- DO A MULLIKEN POPULATION ANALYSIS -----
C              CALCULATE OVERLAP POPULATION
C
      CALL OVLPOP(X(IDEN),X(I10),L2)
  200 CONTINUE
      IF(POPOUT) THEN
         WRITE(IW,9999) ELEC
      ENDIF
      IF(OUT) THEN
         WRITE(IW,9988)
         CALL PRTRL(X(IDEN),L1)
      ENDIF
C
C     ----- CALCULATE TOTAL GROSS POPULATION IN AO'S ----
C
      CALL GROSSC(X(IDEN),X(IGOC),IA,L1)
      IF(ISPHER.LT.0) THEN
         IF(POPOUT) THEN
            WRITE(IW,9998)
            WRITE(IW,9997) (I, BFLAB(I),X(I-1+IGOC),I=1,L1)
         ENDIF
      ELSE
         IF(POPOUT) THEN
            WRITE(IW,9990)
            WRITE(IW,9997) (I,SPHLAB(I),X(I-1+IGOC),I=1,L1)
         ENDIF
      ENDIF
C
      IF(POPOUT) THEN
         WRITE(IW,9996)
      ENDIF
C
C     ----- COMPRESS FROM -AO- TO SHELLS -----
C
      IF(POPOUT) THEN
         CALL SHLPOP(X(IGOC))
      ENDIF
C
C     ----- COMPRESS FROM -AO- TO ATOMS -----
C
      CALL ATMPOP(X(IDEN),IA,X(I30),NAT)
      IF(OUT) THEN
         CALL PRTR(X(I30),NAT)
      ENDIF
C
C     ----- CALCULATE TOTAL GROSS POPULATION ON ATOMS -----
C
      CALL GROSSC(X(I30),X(IGAC),IA,NAT)
      IF(POPOUT) THEN
         WRITE(IW,9995)
         WRITE(IW,9992) (I,ANAM(I),BNAM(I),ZNUC(I),ZAN(I),
     1                   X(I-1+IGAC),I=1,NAT)
      ENDIF
      DO IAT=1,NAT
         POPMLK(IAT)=  X(IAT+IGAC-1)
         CHGMLK(IAT)=-(X(IAT+IGAC-1)-ZAN(IAT))
      ENDDO
C
      IF((WFNTYP.NE.SCF.OR.SCFTYP.NE.UHF).AND.
     1   (WFNTYP.NE.MP2.OR.SCFTYP.NE.UHF)     ) GO TO 400
      IF(LAST      ) GO TO 400
      IF(IPASS.EQ.2) GO TO 300
      IPASS=2
      IDEN=I41
      IGOC=I51
      IGAC=I61
      ELEC=BETA
      GO TO 100
  300 CONTINUE
C
C     ----- CALCULATE ORBITAL AND ATOMIC SPIN DENSITIES -----
C
      DO I=1,L1
         X(I-1+I50)=X(I-1+I50)-X(I-1+I51)
      ENDDO
      DO I=1,NAT
         X(I-1+I60)=X(I-1+I60)-X(I-1+I61)
      ENDDO
      IF(ISPHER.LT.0) THEN
         IF(POPOUT) THEN
            WRITE(IW,9994)
            WRITE(IW,9997) (I, BFLAB(I),X(I-1+I50),I=1,NUM)
         ENDIF
      ELSE
         IF(POPOUT) THEN
            WRITE(IW,9987)
            WRITE(IW,9997) (I,SPHLAB(I),X(I-1+I50),I=1,NUM)
         ENDIF
      ENDIF
      IF(POPOUT) THEN
         WRITE(IW,9993)
         WRITE(IW,9992) (I,ANAM(I),BNAM(I),ZNUC(I),ZAN(I),
     1                   X(I-1+I60),I=1,NAT)
      ENDIF
      DO IAT=1,NAT
         SPNMLK(IAT)=  X(IAT+I60-1)
      ENDDO
C
C     ----- DO ALL ELECTRONS -----
C
      IPASS=1
      LAST=.TRUE.
      ELEC=ALL
      DO I=1,L2
         X(I-1+I40)=X(I-1+I40)+X(I-1+I41)
      ENDDO
      IDEN=I40
      IGOC=I50
      IGAC=I60
      GO TO 200
  400 CONTINUE
C
C     ----- BOND INDEX AND VALENCY ANALYSIS -----
C
      DO I=1,L2
         X(I+I41-1)=ZERO
      ENDDO
      CALL DAREAD(IDAF,IODA,X(I10),L2,12)
      CALL PRPDEN(X(I40),X(I41),L2)
      IF((WFNTYP.EQ.SCF.AND.SCFTYP.EQ.UHF).OR.
     1   (WFNTYP.EQ.MP2.AND.SCFTYP.EQ.UHF)    ) THEN
         DO I=1,L2
            DUMA=X(I+I40-1)
            DUMB=X(I+I41-1)
            X(I+I40-1)=DUMA+DUMB
            X(I+I41-1)=DUMA-DUMB
         ENDDO
      ENDIF
      IF(POPOUT) THEN
         CALL APSPOP(X(I10),X(I40),X(I41),X(I51),X(I83),
     1               X(I53),X(I63),X(I73),X(I93),X(I94),
     2               IA,NAT,NUM)
      ENDIF
C
 1000 CONTINUE
C
C     ----- RESET CORE MEMORY -----
C
      CALL CMEM(NGOTCM)
      IF(NGOTCM.NE.LOADCM) CALL SETC(LOADCM)
      RETURN
 9999 FORMAT(//,10X,28(1H-),/,10X,'MULLIKEN POPULATION ANALYSIS',
     1 10X,A8,' ELECTRONS',/,10X,28(1H-))
 9998 FORMAT(/,10X,'----- TOTAL GROSS POPULATION IN AO -----',/)
 9997 FORMAT(5(I5,1X,A8,F11.5))
 9996 FORMAT(/,10X,'----- CONDENSED TO ATOMS -----',/)
 9995 FORMAT(/,10X,'----- TOTAL GROSS POPULATION ON ATOMS ----',/)
 9994 FORMAT(/,10X,'----- SPIN POPULATION IN AO -----',/)
 9993 FORMAT(/,10X,'----- ATOMIC SPIN POPULATION -----',/)
 9992 FORMAT(10X,I5,2X,A8,A2,F6.1,F6.1,F12.5)
 9991 FORMAT(' NOT ENOUGH MEMORY IN -LOWDIN- . THE PROGRAM WILL BYPASS',
     1       ' THIS STEP AND CONTINUE.')
 9990 FORMAT(/,10X,'----- TOTAL GROSS POPULATION IN SPH.HARM. -----',/)
 9989 FORMAT(/,10X,'----- OVERLAP MATRIX IN -AO- BASIS-----')
 9988 FORMAT(/,10X,'----- OVERLAP POPULATION -----')
 9987 FORMAT(/,10X,'----- SPIN POPULATION IN SPH.HARM. -----',/)
 9986 FORMAT(/,10X,'----- OVERLAP MATRIX IN -SPH.HARM.- BASIS -----')
      END
