      SUBROUTINE DIAGIV(A,VEC,EIG,IA,NVEC,N,NDIM)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C     ----- GENERAL CALLING  ROUTINE FOR -----
C               -GIVEIS- OR -GIVDIA-
C     ----------------------------------------------------------
C     NOTE: GIVDIA IS NOT AS FAST AND LESS RELIABLE THAN GIVEIS
C           THIS IS PARTICULARLY TRUE ON THE VAX.   S.T.ELBERT
C     ----------------------------------------------------------
C
      CHARACTER*8 ERRMSG
C#g77 COMMON/IOFILE/IR,IW
      COMMON/IOFILE/IR,IW,IP
      COMMON/DIAOPT/MODDIA
      DIMENSION A(1),VEC(NDIM,1),EIG(1),IA(1)
      DIMENSION ERRMSG(3)
      DATA ERRMSG /'PROGRAM ','STOP IN ','-DIAGIV-'/
      IERR=0
      IF(MODDIA.EQ.0) CALL GIVDIA(A,VEC,EIG,IA,N,NDIM)
      IF(MODDIA.NE.0) CALL GIVEIS(A,VEC,EIG,NVEC,N,NDIM,IERR)
      IF(IERR.EQ.0) RETURN
      WRITE(IW,9999) IERR
      CALL HNDERR(3,ERRMSG)
      RETURN
 9999 FORMAT(' ERROR IN -GIVEIS- . STOP -IERR- = ',I5)
      END
      SUBROUTINE GIVEIS(A,VECT,ROOT,NVECT,N,NDIM,IERR)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (MXBFN=3072)
      DIMENSION A(1),ROOT(1),VECT(NDIM,1)
      DIMENSION B(MXBFN,9)
C
C     EISPACK-BASED SUBSTITUTE FOR QCPE ROUTINE GIVENS.
C     FINDS ALL EIGENVALUES AND SOME EIGENVECTORS OF A REAL SYMMETRIC
C     MATRIX.   AUTHOR.. C. MOLER AND D. SPANGLER, N.R.C.C., 4/1/79.
C
C     INPUT..
C     NVECT = NUMBER OF VECTORS DESIRED.  0 .LE. NVECT .LE. N .
C     N     = ORDER OF MATRIX .
C     NDIM  = ROW DIMENSION OF VECT .
C     A     = INPUT MATRIX, COLUMNS OF THE UPPER TRIANGLE PACKED INTO
C             LINEAR ARRAY OF DIMENSION N*(N+1)/2 .
C     B     = SCRATCH ARRAY, 9*N ELEMENTS (NOTE THIS IS MORE THAN
C             PREVIOUS VERSIONS OF GIVENS.)
C
C     OUTPUT..
C     A       DESTORYED .
C     ROOT  = ALL EIGENVALUES, ROOT(1) .LE. ... .LE. ROOT(N) .
C             (FOR OTHER ORDERINGS, SEE BELOW.)
C     VECT  = EIGENVECTORS FOR ROOT(1),..., ROOT(NVECT) .
C     IERR  = 0 IF NO ERROR DETECTED,
C           = K IF ITERATION FOR K-TH EIGENVALUE FAILED,
C           = -K IF ITERATION FOR K-TH EIGENVECTOR FAILED.
C             (FAILURES SHOULD BE VERY RARE.  CONTACT MOLER.)
C
C     CALLS MODIFIED EISPACK ROUTINES TRED3B, IMTQLV, TINVTB, AND
C     TRBK3B.  THE ROUTINES TRED3B, TINVTB, AND TRBK3B.
C     THE ORIGINAL EISPACK ROUTINES TRED3, TINVIT, AND TRBAK3
C     WERE MODIFIED BY THE INTRODUCTION OF TWO ROUTINES FROM THE
C     BLAS LIBRARY - DDOT AND DAXPY.
C
C         IF TINVIT FAILS TO CONVERGE, TQL2 IS CALLED
C
C         SEE EISPACK USERS GUIDE, B. T. SMITH ET AL, SPRINGER-VERLAG
C     LECTURE NOTES IN COMPUTER SCIENCE, VOL. 6, 2-ND EDITION, 1976 .
C     NOTE THAT IMTQLV AND TINVTB HAVE INTERNAL HARDWARE
C     DEPENDENT CONSTANTS.
C
      DATA ONE, ZERO /1.0D+00, 0.0D+00/
      CALL TRED3B(N,(N*N+N)/2,A,B(1,1),B(1,2),B(1,3))
      CALL IMTQLV(N,B(1,1),B(1,2),B(1,3),ROOT,B(1,9),IERR,B(1,4))
      IF (IERR .NE. 0) RETURN
C
C     TO REORDER ROOTS...
C     K = N/2
C     B(1,3) = 2.0D+00
C     DO 50 I = 1, K
C        J = N+1-I
C        T = ROOT(I)
C        ROOT(I) = ROOT(J)
C        ROOT(J) = T
C 50  CONTINUE
C
      IF (NVECT .LE. 0) RETURN
      CALL TINVTB(NDIM,   N,B(1,1),B(1,2),B(1,3),NVECT,ROOT,B(1,9),
     1            VECT,IERR,B(1,4),B(1,5),B(1,6),B(1,7),B(1,8))
      IF (IERR .EQ. 0) GO TO 160
C
C      IF INVERSE ITERATION GIVES AN ERROR IN DETERMINING THE
C      EIGENVECTORS, TRY THE QL ALGORITHM IF ALL THE EIGENVECTORS
C      ARE DESIRED.
C
      IF (NVECT .NE. N) RETURN
      DO 120 I = 1, NVECT
      DO 100 J = 1, N
      VECT(I,J) = ZERO
  100 CONTINUE
      VECT(I,I) = ONE
  120 CONTINUE
      CALL TQL2 (NDIM,N,B(1,1),B(1,2),VECT,IERR)
      DO 140 I = 1, NVECT
      ROOT(I) = B(I,1)
  140 CONTINUE
      IF (IERR .NE. 0) RETURN
  160 CALL TRBK3B(NDIM,N,(N*N+N)/2,A,NVECT,VECT)
      RETURN
      END
