      SUBROUTINE DROOT
      IMPLICIT REAL*16 (A-H,O-Z)
      REAL*8 XX,UF,WF
      COMMON/HFK/XX,UF(9),WF(9),NROOTS
      COMMON/RYSFF/FF(19)
      COMMON/RYSRW/R(9,9),W(9,9)
      DIMENSION C(10,10),S(10,10),A(10),RT(10)
      DATA PT5,ZERO,ONE,FOUR /0.5Q+00,0.0Q+00,1.0Q+00,4.0Q+00/
C
C     THIS VERSION USES CHRISTOFFEL FORMULA FOR WEIGHTS.
C     ITH ROOT OF THE JTH RYS POLYNOMIAL IS RETURNED IN R(I,J) WITH
C     THE CORRESPONDING WEIGHT FACTOR IN W(I,J).   J=1,2,...,N
C
      N=NROOTS
      X=XX
      IF(N.LT.2) N=2
      N1=N+1
      NN=N+N
      CALL RYSFUN(X,NN)
      DO 10 I=1,N1
      DO 10 J=1,N1
   10 S(I,J)=FF(I+J-1)
      CALL RYSSMT(C,S,N1)
      DO 20 I=1,N
      DO 20 J=1,I
      W(I,J)= ZERO
   20 R(I,J)= ZERO
      WSUM=FF(1)
      W(1,1)=WSUM
      R(1,1)=FF(2)/WSUM
      DUM= SQRT(C(2,3)**2-FOUR *C(1,3)*C(3,3))
      R(1,2)=   PT5 *(-C(2,3)-DUM)/C(3,3)
      R(2,2)=   PT5 *(-C(2,3)+DUM)/C(3,3)
      IF(N.EQ.2) GO TO 70
      DO 25 I=3,N1
   25 RT(I)=  ONE
      RT(1)=R(1,2)
      RT(2)=R(2,2)
      DO 60 K=3,N
      K1=K+1
      DO 30 I=1,K1
   30 A(I)=C(I,K1)
      CALL RYSNOD(A,RT,K)
      DO 50 I=1,K
   50 R(I,K)=RT(I)
   60 CONTINUE
   70 DO 150 K=2,N
      JMAX=K-1
      DO 150 I=1,K
      ROOT=R(I,K)
      DUM=  ONE  /FF(1)
      DO 110 J=1,JMAX
      J1=J+1
      POLY=C(J1,J1)
      DO 100 M=1,J
  100 POLY=POLY*ROOT+C(J1-M,J1)
  110 DUM=DUM+POLY*POLY
  150 W(I,K)=  ONE  /DUM
      DO 160 K=1,NROOTS
      DUM=R(K,NROOTS)
      UF(K)=DUM/(  ONE  -DUM)
  160 WF(K)=W(K,NROOTS)
      RETURN
      END
      SUBROUTINE RYSSMT(C,S,N)
      IMPLICIT REAL*16 (A-H,O-Z)
      DIMENSION C(10,10),S(10,10),V(10),Y(10)
      DATA ZERO,ONE /0.0Q+00,1.0Q+00/
C
C     ROUTINE RETURNS AN N BY N TRIANGULAR MATRIX C SUCH THAT
C     C(TRANSPOSE)SC=I,  WHERE I IS AN N BY N IDENTITY MATRIX.
C
      DO 10 I=1,N
      DO 10 J=1,I
   10 C(I,J)= ZERO
      DO 100 J=1,N
      KMAX=J-1
      FAC=S(J,J)
      IF(KMAX.EQ.0) GO TO 60
      DO 20 K=1,KMAX
      V(K)= ZERO
   20 Y(K)=S(K,J)
      DO 50 K=1,KMAX
      DOT= ZERO
      DO 30 I=1,K
   30 DOT=C(I,K)*Y(I)+DOT
      DO 40 I=1,K
   40 V(I)=V(I)-DOT*C(I,K)
   50 FAC=FAC-DOT*DOT
   60 FAC=ONE/ SQRT(FAC)
      C(J,J)=FAC
      IF(KMAX.EQ.0) GO TO 100
      DO 70 K=1,KMAX
   70 C(K,J)=FAC*V(K)
  100 CONTINUE
      RETURN
      END
      SUBROUTINE RYSFUN(X,N)
      IMPLICIT REAL*16 (A-H,O-Z)
      COMMON/RYSFF/FF(19)
      DATA PT5,ONE,TWO /0.5Q+00,1.0Q+00,2.0Q+00/
      TOL=1.0Q-14
      XX=X+X
      FACMIN=XX
      E=0.5409855304296342219319112Q-78
      IF(FACMIN.LT.2*180.2160Q+00) E= EXP(-X)
      IF(FACMIN.GT.   80.0000Q+00) GO TO 100
      TERM=ONE
      SUM =ONE
      FAC=N
      FAC=FAC+PT5
   10 FAC=FAC+ONE
      TERM=TERM*X/FAC
      SUM=SUM+TERM
      IF(FAC.LE.FACMIN) GO TO 10
      T=TERM
      S=SUM
      IF(T.GT.S*TOL) GO TO 10
      FAC=N+N+1
      FF(N+1)=SUM*E/FAC
      M=N-1
      FAC=M+M+1
   20 IF(M.LT.0) RETURN
      FF(M+1)=(E+XX*FF(M+2))/FAC
      M=M-1
      FAC=FAC-TWO
      GO TO 20
C
C     USE ASYMPTOTIC EXPANSION FOR LARGE ARGUMENTS.
C
  100 A= SQRT(.7853981633974483096156608Q+00/X)
      TMAX=A*TOL/E
      TERM=ONE/XX
      SUM=TERM
      FAC=ONE
  110 FAC=FAC-TWO
      TERM=FAC*TERM/XX
      SUM=TERM+SUM
      T=TERM
      IF( ABS(T).GT.TMAX) GO TO 110
      FF(1)=A-E*SUM
      FAC=-ONE
      M=0
  120 IF(M.EQ.N) RETURN
      M=M+1
      FAC=FAC+TWO
      FF(M+1)=(FAC*FF(M)-E)/XX
      GO TO 120
      END
      SUBROUTINE RYSNOD(A,RT,K)
      IMPLICIT REAL*16 (A-H,O-Z)
      CHARACTER*8 ERRMSG
      DIMENSION A(10),RT(10)
      DIMENSION ERRMSG(3)
      DATA ERRMSG /'PROGRAM ','STOP IN ','-RYSNOD-'/
      DATA ZERO /0.0Q+00/
C
C     ROUTINE RETURNS RT(I) THE ITH ROOT OF A POLYNOMIAL OF ORDER
C     K WHOSE MTH COEFFICIENT IS STORED IN A(M+1).  IT IS ASSUMED THAT
C     THE INITIAL VALUES IN RT BRACKET THE FINAL VALUES.
C
      TOL=1.0Q-11
      K1=K+1
      R2= ZERO
      P2=A(1)
      DO 100 M=1,K
      R1=R2
      P1=P2
      R2=RT(M)
      P2=A(K1)
      DO 10 I=1,K
   10 P2=P2*R2+A(K1-I)
      PROD=P1*P2
      IF(PROD.LT. ZERO) GO TO 20
      WRITE(6,15) M,K
   15 FORMAT(//,' ROOT NUMBER ',I3,' WAS NOT FOUND FOR POLYNOMIAL',
     1 ' OF ORDER ',I3,//)
      CALL HNDERR(3,ERRMSG)
   20 R5=R1
      P5=P1
      R6=R2
      P6=P2
   30 R3=R5
      P3=P5
      R4=R6
      P4=P6
      R =(R3*P4-R4*P3)/(P4-P3)
      DR=R4-R3
      DELTA=DR
      IF( ABS(DELTA).LT.TOL) GO TO 90
      DR=0.0625Q+00*DR
      R5=R-DR
      IF(R5.LT.R3) R5=R3
      R6=R+DR
      IF(R6.GT.R4) R6=R4
      P5=A(K1)
      P6=P5
      DO 40 I=1,K
      P5=P5*R5+A(K1-I)
   40 P6=P6*R6+A(K1-I)
   45 PROD=P5*P6
      IF(PROD.LT. ZERO) GO TO 30
      PROD=P3*P5
      IF(PROD.GT. ZERO) GO TO 60
      R5=0.25Q+00*R3+0.75Q+00*R5
      P5=A(K1)
      DO 50 I=1,K
   50 P5=P5*R5+A(K1-I)
      GO TO 45
   60 R6=0.25Q+00*R4+0.75Q+00*R6
      P6=A(K1)
      DO 70 I=1,K
   70 P6=P6*R6+A(K1-I)
      GO TO 45
   90 RT(M)=R
  100 CONTINUE
      RETURN
      END
