CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     HONDO : ESSL FORTRAN
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C FOLLOWING ROUTINES ARE DEFINED IN THIS MODULE
C
C     DAXPY
C     DCOPY
C     DSCAL
C     DSWAP
C     DGEMUL
C     DGEMM
C     DNAXPY
C     DNDOT
C     DGEMV
C     DGEMX
C     DGEMTX
C     DYAX
C     DGER1
C     DASUM
C     DNRM2
C
      SUBROUTINE DAXPY(N,DA,DX,INCX,DY,INCY)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C     CONSTANT TIMES A VECTOR PLUS A VECTOR.
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DIMENSION DX(1),DY(1)
      DATA ZERO /0.0D+00/
      IF(N.LE.0)RETURN
      IF (DA .EQ. ZERO ) RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
C          NOT EQUAL TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        DY(IY) = DY(IY) + DA*DX(IX)
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      RETURN
C
C        CODE FOR BOTH INCREMENTS EQUAL TO 1
C
C
C        CLEAN-UP LOOP
C
   20 M = MOD(N,4)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
        DY(I) = DY(I) + DA*DX(I)
   30 CONTINUE
      IF( N .LT. 4 ) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,4
        DY(I) = DY(I) + DA*DX(I)
        DY(I + 1) = DY(I + 1) + DA*DX(I + 1)
        DY(I + 2) = DY(I + 2) + DA*DX(I + 2)
        DY(I + 3) = DY(I + 3) + DA*DX(I + 3)
   50 CONTINUE
      RETURN
      END
      SUBROUTINE DCOPY(N,DX,INCX,DY,INCY)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C     COPIES A VECTOR, X, TO A VECTOR, Y.
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DIMENSION DX(1),DY(1)
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
C          NOT EQUAL TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        DY(IY) = DX(IX)
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      RETURN
C
C        CODE FOR BOTH INCREMENTS EQUAL TO 1
C
C
C        CLEAN-UP LOOP
C
   20 M = MOD(N,7)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
        DY(I) = DX(I)
   30 CONTINUE
      IF( N .LT. 7 ) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,7
        DY(I) = DX(I)
        DY(I + 1) = DX(I + 1)
        DY(I + 2) = DX(I + 2)
        DY(I + 3) = DX(I + 3)
        DY(I + 4) = DX(I + 4)
        DY(I + 5) = DX(I + 5)
        DY(I + 6) = DX(I + 6)
   50 CONTINUE
      RETURN
      END
      SUBROUTINE SCOPY(N,DX,INCX,DY,INCY)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C     COPIES A VECTOR, X, TO A VECTOR, Y.
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      INTEGER*4 DX   ,DY
      DIMENSION DX(1),DY(1)
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
C          NOT EQUAL TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        DY(IY) = DX(IX)
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      RETURN
C
C        CODE FOR BOTH INCREMENTS EQUAL TO 1
C
C
C        CLEAN-UP LOOP
C
   20 M = MOD(N,7)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
        DY(I) = DX(I)
   30 CONTINUE
      IF( N .LT. 7 ) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,7
        DY(I) = DX(I)
        DY(I + 1) = DX(I + 1)
        DY(I + 2) = DX(I + 2)
        DY(I + 3) = DX(I + 3)
        DY(I + 4) = DX(I + 4)
        DY(I + 5) = DX(I + 5)
        DY(I + 6) = DX(I + 6)
   50 CONTINUE
      RETURN
      END
      FUNCTION DDOT(N,DX,INCX,DY,INCY)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C     FORMS THE DOT PRODUCT OF TWO VECTORS.
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DIMENSION DX(1),DY(1)
      DATA ZERO /0.0D+00/
      DDOT = ZERO
      DTEMP = ZERO
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
C          NOT EQUAL TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        DTEMP = DTEMP + DX(IX)*DY(IY)
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      DDOT = DTEMP
      RETURN
C
C        CODE FOR BOTH INCREMENTS EQUAL TO 1
C
C
C        CLEAN-UP LOOP
C
   20 M = MOD(N,5)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
        DTEMP = DTEMP + DX(I)*DY(I)
   30 CONTINUE
      IF( N .LT. 5 ) GO TO 60
   40 MP1 = M + 1
      DO 50 I = MP1,N,5
        DTEMP = DTEMP + DX(I    )*DY(I    ) + DX(I + 1)*DY(I + 1) +
     1                  DX(I + 2)*DY(I + 2) + DX(I + 3)*DY(I + 3) +
     2                  DX(I + 4)*DY(I + 4)
   50 CONTINUE
   60 DDOT = DTEMP
      RETURN
      END
      SUBROUTINE DSCAL(N,DA,DX,INCX)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C     SCALES A VECTOR BY A CONSTANT.
C     USES UNROLLED LOOPS FOR INCREMENT EQUAL TO ONE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DIMENSION DX(1)
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1)GO TO 20
C
C        CODE FOR INCREMENT NOT EQUAL TO 1
C
      NINCX = N*INCX
      DO 10 I = 1,NINCX,INCX
        DX(I) = DA*DX(I)
   10 CONTINUE
      RETURN
C
C        CODE FOR INCREMENT EQUAL TO 1
C
C
C        CLEAN-UP LOOP
C
   20 M = MOD(N,5)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
        DX(I) = DA*DX(I)
   30 CONTINUE
      IF( N .LT. 5 ) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,5
        DX(I) = DA*DX(I)
        DX(I + 1) = DA*DX(I + 1)
        DX(I + 2) = DA*DX(I + 2)
        DX(I + 3) = DA*DX(I + 3)
        DX(I + 4) = DA*DX(I + 4)
   50 CONTINUE
      RETURN
      END
      SUBROUTINE DSWAP(N,DX,INCX,DY,INCY)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C     INTERCHANGES TWO VECTORS.
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL ONE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DIMENSION DX(1),DY(1)
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C       CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS NOT EQUAL
C         TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        DTEMP = DX(IX)
        DX(IX) = DY(IY)
        DY(IY) = DTEMP
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      RETURN
C
C       CODE FOR BOTH INCREMENTS EQUAL TO 1
C
C
C       CLEAN-UP LOOP
C
   20 M = MOD(N,3)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
        DTEMP = DX(I)
        DX(I) = DY(I)
        DY(I) = DTEMP
   30 CONTINUE
      IF( N .LT. 3 ) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,3
        DTEMP = DX(I)
        DX(I) = DY(I)
        DY(I) = DTEMP
        DTEMP = DX(I + 1)
        DX(I + 1) = DY(I + 1)
        DY(I + 1) = DTEMP
        DTEMP = DX(I + 2)
        DX(I + 2) = DY(I + 2)
        DY(I + 2) = DTEMP
   50 CONTINUE
      RETURN
      END
      FUNCTION IDAMAX(N,DX,INCX)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C     FINDS THE INDEX OF ELEMENT HAVING MAX. ABSOLUTE VALUE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DIMENSION DX(1)
      IDAMAX = 0
      IF( N .LT. 1 ) RETURN
      IDAMAX = 1
      IF(N.EQ.1) RETURN
      IF(INCX.EQ.1) GO TO 30
C
C        CODE FOR INCREMENT NOT EQUAL TO 1
C
      IX = 1
      DMAX = ABS(DX(1))
      IX = IX + INCX
      DO 20 I = 2,N
         IF( ABS(DX(IX)).LE.DMAX) GO TO 10
         IDAMAX = I
         DMAX = ABS(DX(IX))
   10    IX = IX + INCX
   20 CONTINUE
      RETURN
C
C        CODE FOR INCREMENT EQUAL TO 1
C
   30 DMAX = ABS(DX(1))
      DO 40 I = 2,N
         IF( ABS(DX(I)).LE.DMAX) GO TO 40
         IDAMAX = I
         DMAX = ABS(DX(I))
   40 CONTINUE
      RETURN
      END
      SUBROUTINE DGEMUL(A,LDA,FORMA,B,LDB,FORMB,C,LDC,L,M,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*1 FORMA,FORMB
      REAL*8 A(LDA), B(LDB), C(LDC)
      DATA ZERO /0.0D+00/
C
      IF (FORMA.EQ.'N' .AND. FORMB.EQ.'N') THEN
         DO 30 IL = 1, L
            DO 20 IN = 1, N
               T = ZERO
               DO 10 IM = 1, M
                  T = T + A((IM-1)*LDA+IL)*B((IN-1)*LDB+IM)
   10          CONTINUE
               C((IN-1)*LDC+IL) = T
   20       CONTINUE
   30    CONTINUE
      ELSE IF (FORMA.EQ.'T' .AND. FORMB.EQ.'N') THEN
         DO 130 IL = 1, L
            DO 120 IN = 1, N
               T = ZERO
               DO 110 IM = 1, M
                  T = T + A((IL-1)*LDA+IM)*B((IN-1)*LDB+IM)
  110          CONTINUE
               C((IN-1)*LDC+IL) = T
  120       CONTINUE
  130    CONTINUE
      ELSE IF (FORMA.EQ.'N' .AND. FORMB.EQ.'T') THEN
         DO 230 IL = 1, L
            DO 220 IN = 1, N
               T = ZERO
               DO 210 IM = 1, M
                  T = T + A((IM-1)*LDA+IL)*B((IM-1)*LDB+IN)
  210          CONTINUE
               C((IN-1)*LDC+IL) = T
  220       CONTINUE
  230    CONTINUE
      ELSE
         DO 330 IL = 1, L
            DO 320 IN = 1, N
               T = ZERO
               DO 310 IM = 1, M
                  T = T + A((IL-1)*LDA+IM)*B((IM-1)*LDB+IN)
  310          CONTINUE
               C((IN-1)*LDC+IL) = T
  320       CONTINUE
  330    CONTINUE
      END IF
      RETURN
      END
      SUBROUTINE DGEMM(FORMA,FORMB,L,N,M,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*1 FORMA,FORMB
      REAL*8 A(LDA), B(LDB), C(LDC)
      DATA ZERO /0.0D+00/
C
      IF (FORMA.EQ.'N' .AND. FORMB.EQ.'N') THEN
         DO 30 IL = 1, L
            DO 20 IN = 1, N
               T = ZERO
               DO 10 IM = 1, M
                  T = T + A((IM-1)*LDA+IL)*B((IN-1)*LDB+IM)
   10          CONTINUE
               C((IN-1)*LDC+IL) = BETA*C((IN-1)*LDC+IL) + ALPHA*T
   20       CONTINUE
   30    CONTINUE
      ELSE IF (FORMA.EQ.'T' .AND. FORMB.EQ.'N') THEN
         DO 130 IL = 1, L
            DO 120 IN = 1, N
               T = ZERO
               DO 110 IM = 1, M
                  T = T + A((IL-1)*LDA+IM)*B((IN-1)*LDB+IM)
  110          CONTINUE
               C((IN-1)*LDC+IL) = BETA*C((IN-1)*LDC+IL) + ALPHA*T
  120       CONTINUE
  130    CONTINUE
      ELSE IF (FORMA.EQ.'N' .AND. FORMB.EQ.'T') THEN
         DO 230 IL = 1, L
            DO 220 IN = 1, N
               T = ZERO
               DO 210 IM = 1, M
                  T = T + A((IM-1)*LDA+IL)*B((IM-1)*LDB+IN)
  210          CONTINUE
               C((IN-1)*LDC+IL) = BETA*C((IN-1)*LDC+IL) + ALPHA*T
  220       CONTINUE
  230    CONTINUE
      ELSE
         DO 330 IL = 1, L
            DO 320 IN = 1, N
               T = ZERO
               DO 310 IM = 1, M
                  T = T + A((IL-1)*LDA+IM)*B((IM-1)*LDB+IN)
  310          CONTINUE
               C((IN-1)*LDC+IL) = BETA*C((IN-1)*LDC+IL) + ALPHA*T
  320       CONTINUE
  330    CONTINUE
      END IF
      RETURN
      END
      SUBROUTINE DNAXPY(N,M,A,INCA,X,INCXI,INCXO,Y,INCYI,INCYO)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 A((N-1)*INCA+1),
     1       X(((M-1)*INCXI+1)*((N-1)*INCXO+1)),
     2       Y(((M-1)*INCYI+1)*((N-1)*INCYO+1))
      DO 10 I = 1, N
         CALL DAXPY(M,A(1+(I-1)*INCA),
     1                X(1+(I-1)*INCXO),INCXI,
     2                Y(1+(I-1)*INCYO),INCYI)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE DNDOT(N,M,S,INCS,ISW,X,INCXI,INCXO,Y,INCYI,INCYO)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 S(1+(N-1)*INCS),
     1       X((1+(M-1)*INCXI)*(1+(N-1)*INCXO)),
     2       Y((1+(M-1)*INCYI)*(1+(N-1)*INCYO))
      IF (ISW.EQ.1) THEN
         DO 10 I = 1, N
            S(1+(I-1)*INCS) = DDOT(M,X(1+(I-1)*INCXO),INCXI,
     1                               Y(1+(I-1)*INCYO),INCYI)
   10    CONTINUE
      ELSE IF (ISW.EQ.2) THEN
         DO 20 I = 1, N
            S(1+(I-1)*INCS) =-DDOT(M,X(1+(I-1)*INCXO),INCXI,
     1                               Y(1+(I-1)*INCYO),INCYI)
   20    CONTINUE
      ELSE IF (ISW.EQ.3) THEN
         DO 30 I = 1, N
            S(1+(I-1)*INCS) = S(1+(I-1)*INCS) +
     1                        DDOT(M,X(1+(I-1)*INCXO),INCXI,
     2                               Y(1+(I-1)*INCYO),INCYI)
   30    CONTINUE
      ELSE IF (ISW.EQ.4) THEN
         DO 40 I = 1, N
            S(1+(I-1)*INCS) = S(1+(I-1)*INCS) -
     1                        DDOT(M,X(1+(I-1)*INCXO),INCXI,
     2                               Y(1+(I-1)*INCYO),INCYI)
   40    CONTINUE
      ELSE
         STOP ' ISW IS OUT OF RANGE IN DNDOT'
      END IF
      RETURN
      END
      SUBROUTINE DGEMV(FORMA,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*1 FORMA
      DIMENSION A(1+(N-1)*LDA),X(1+(N-1)*INCX),Y(1+(M-1)*INCY)
      DATA ZERO /0.0D+00/
      IF(FORMA .EQ. 'N' ) THEN
         DO 20 I = 1, M
            T = ZERO
            DO 10 J = 1, N
               T = T + A((J-1)*LDA+I) * X(1+(J-1)*INCX)
   10       CONTINUE
            Y(1+(I-1)*INCY) = BETA*Y(1+(I-1)*INCY) + ALPHA*T
   20    CONTINUE
      ELSE
         DO 40 I = 1, N
            T = ZERO
            DO 30 J = 1, M
               T = T + A((I-1)*LDA+J) * X(1+(J-1)*INCX)
   30       CONTINUE
            Y(1+(I-1)*INCY) = BETA*Y(1+(I-1)*INCY) + ALPHA*T
   40    CONTINUE
      ENDIF
      RETURN
      END
      SUBROUTINE DGEMX(M,N,ALPHA,A,LDA,X,INCX,Y,INCY)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(1+(N-1)*LDA),X(1+(N-1)*INCX),Y(1+(M-1)*INCY)
      DATA ZERO /0.0D+00/
      DO 20 I = 1, M
         T = ZERO
         DO 10 J = 1, N
            T = T + A((J-1)*LDA+I) * X(1+(J-1)*INCX)
   10    CONTINUE
         Y(1+(I-1)*INCY) = Y(1+(I-1)*INCY) + ALPHA*T
   20 CONTINUE
      RETURN
      END
      SUBROUTINE DGEMTX(M,N,ALPHA,A,LDA,X,INCX,Y,INCY)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(1+(N-1)*LDA),X(1+(M-1)*INCX),Y(1+(N-1)*INCY)
      DATA ZERO /0.0D+00/
      DO 20 I = 1, N
         T = ZERO
         DO 10 J = 1, M
            T = T + A((I-1)*LDA+J) * X(1+(J-1)*INCX)
   10    CONTINUE
         Y(1+(I-1)*INCY) = Y(1+(I-1)*INCY) + ALPHA*T
   20 CONTINUE
      RETURN
      END
      SUBROUTINE DYAX(N,ALPHA,X,INCX,Y,INCY)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(1+(N-1)*INCX), Y(1+(N-1)*INCY)
      DO 10 I = 1, N
         Y(1+(I-1)*INCY) = ALPHA * X(1+(I-1)*INCX)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE DGER1(M,N,ALPHA,X,INCX,Y,INCY,A,LDA)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(1+(M-1)*INCX), Y(1+(N-1)*INCY),
     1          A(1+(N-1)*LDA)
      DO 20 I = 1, M
         DO 10 J = 1, N
         A(I+(J-1)*LDA) = A(I+(J-1)*LDA) + ALPHA *
     1                    X(1+(I-1)*INCX)*Y(1+(J-1)*INCY)
   10    CONTINUE
   20 CONTINUE
      RETURN
      END
      SUBROUTINE DROTG(DA,DB,C,S)
C
C     CONSTRUCT GIVENS PLANE ROTATION.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DOUBLE PRECISION DA,DB,C,S,ROE,SCALE,R,Z
C
      ROE = DB
      IF( DABS(DA) .GT. DABS(DB) ) ROE = DA
      SCALE = DABS(DA) + DABS(DB)
      IF( SCALE .NE. 0.0D0 ) GO TO 10
         C = 1.0D0
         S = 0.0D0
         R = 0.0D0
         GO TO 20
   10 R = SCALE*DSQRT((DA/SCALE)**2 + (DB/SCALE)**2)
      R = DSIGN(1.0D0,ROE)*R
      C = DA/R
      S = DB/R
   20 Z = 1.0D0
      IF( DABS(DA) .GT. DABS(DB) ) Z = S
      IF( DABS(DB) .GE. DABS(DA) .AND. C .NE. 0.0D0 ) Z = 1.0D0/C
      DA = R
      DB = Z
      RETURN
      END
      SUBROUTINE  DROT (N,DX,INCX,DY,INCY,C,S)
C
C     APPLIES A PLANE ROTATION.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DOUBLE PRECISION DX(1),DY(1),DTEMP,C,S
      INTEGER I,INCX,INCY,IX,IY,N
C
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C       CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS NOT EQUAL
C         TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        DTEMP = C*DX(IX) + S*DY(IY)
        DY(IY) = C*DY(IY) - S*DX(IX)
        DX(IX) = DTEMP
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      RETURN
C
C       CODE FOR BOTH INCREMENTS EQUAL TO 1
C
   20 DO 30 I = 1,N
        DTEMP = C*DX(I) + S*DY(I)
        DY(I) = C*DY(I) - S*DX(I)
        DX(I) = DTEMP
   30 CONTINUE
      RETURN
      END
      DOUBLE PRECISION FUNCTION DASUM(N,DX,INCX)
C
C     TAKES THE SUM OF THE ABSOLUTE VALUES.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DOUBLE PRECISION DX(1),DTEMP
      INTEGER I,INCX,M,MP1,N,NINCX
C
      DASUM = 0.0D+00
      DTEMP = 0.0D+00
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1)GO TO 20
C
C        CODE FOR INCREMENT NOT EQUAL TO 1
C
      NINCX = N*INCX
      DO 10 I = 1,NINCX,INCX
        DTEMP = DTEMP + ABS(DX(I))
   10 CONTINUE
      DASUM = DTEMP
      RETURN
C
C        CODE FOR INCREMENT EQUAL TO 1
C
C
C        CLEAN-UP LOOP
C
   20 M = MOD(N,6)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
        DTEMP = DTEMP + ABS(DX(I))
   30 CONTINUE
      IF( N .LT. 6 ) GO TO 60
   40 MP1 = M + 1
      DO 50 I = MP1,N,6
        DTEMP = DTEMP + ABS(DX(I)) + ABS(DX(I + 1)) + ABS(DX(I + 2))
     1  + ABS(DX(I + 3)) + ABS(DX(I + 4)) + ABS(DX(I + 5))
   50 CONTINUE
   60 DASUM = DTEMP
      RETURN
      END
      DOUBLE PRECISION FUNCTION DNRM2 ( N, DX, INCX)
      INTEGER          NEXT
      DOUBLE PRECISION   DX(1), CUTLO, CUTHI, HITEST, SUM, XMAX,ZERO,ONE
      DATA   ZERO, ONE /0.0D+00, 1.0D+00/
C
C     EUCLIDEAN NORM OF THE N-VECTOR STORED IN DX() WITH STORAGE
C     INCREMENT INCX .
C     IF    N .LE. 0 RETURN WITH RESULT = 0.
C     IF N .GE. 1 THEN INCX MUST BE .GE. 1
C
C           C.L.LAWSON, 1978 JAN 08
C
C     FOUR PHASE METHOD     USING TWO BUILT-IN CONSTANTS THAT ARE
C     HOPEFULLY APPLICABLE TO ALL MACHINES.
C         CUTLO = MAXIMUM OF  SQRT(U/EPS)  OVER ALL KNOWN MACHINES.
C         CUTHI = MINIMUM OF  SQRT(V)      OVER ALL KNOWN MACHINES.
C     WHERE
C         EPS = SMALLEST NO. SUCH THAT EPS + 1. .GT. 1.
C         U   = SMALLEST POSITIVE NO.   (UNDERFLOW LIMIT)
C         V   = LARGEST  NO.            (OVERFLOW  LIMIT)
C
C     BRIEF OUTLINE OF ALGORITHM..
C
C     PHASE 1    SCANS ZERO COMPONENTS.
C     MOVE TO PHASE 2 WHEN A COMPONENT IS NONZERO AND .LE. CUTLO
C     MOVE TO PHASE 3 WHEN A COMPONENT IS .GT. CUTLO
C     MOVE TO PHASE 4 WHEN A COMPONENT IS .GE. CUTHI/M
C     WHERE M = N FOR X() REAL AND M = 2*N FOR COMPLEX.
C
C     VALUES FOR CUTLO AND CUTHI..
C     FROM THE ENVIRONMENTAL PARAMETERS LISTED IN THE IMSL CONVERTER
C     DOCUMENT THE LIMITING VALUES ARE AS FOLLOWS..
C     CUTLO, S.P.   U/EPS = 2**(-102) FOR  HONEYWELL.  CLOSE SECONDS ARE
C                   UNIVAC AND DEC AT 2**(-103)
C                   THUS CUTLO = 2**(-51) = 4.44089E-16
C     CUTHI, S.P.   V = 2**127 FOR UNIVAC, HONEYWELL, AND DEC.
C                   THUS CUTHI = 2**(63.5) = 1.30438E19
C     CUTLO, D.P.   U/EPS = 2**(-67) FOR HONEYWELL AND DEC.
C                   THUS CUTLO = 2**(-33.5) = 8.23181D-11
C     CUTHI, D.P.   SAME AS S.P.  CUTHI = 1.30438D19
C     DATA CUTLO, CUTHI / 8.232D-11,  1.304D19 /
C     DATA CUTLO, CUTHI / 4.441E-16,  1.304E19 /
      DATA CUTLO, CUTHI / 8.232D-11,  1.304D19 /
C
      IF(N .GT. 0) GO TO 10
         DNRM2  = ZERO
         GO TO 300
C
   10 ASSIGN 30 TO NEXT
      SUM = ZERO
      NN = N * INCX
C                                                 BEGIN MAIN LOOP
      I = 1
   20    GO TO NEXT,(30, 50, 70, 110)
   30 IF( ABS(DX(I)) .GT. CUTLO) GO TO 85
      ASSIGN 50 TO NEXT
      XMAX = ZERO
C
C                        PHASE 1.  SUM IS ZERO
C
   50 IF( DX(I) .EQ. ZERO) GO TO 200
      IF( ABS(DX(I)) .GT. CUTLO) GO TO 85
C
C                                PREPARE FOR PHASE 2.
      ASSIGN 70 TO NEXT
      GO TO 105
C
C                                PREPARE FOR PHASE 4.
C
  100 I = J
      ASSIGN 110 TO NEXT
      SUM = (SUM / DX(I)) / DX(I)
  105 XMAX = ABS(DX(I))
      GO TO 115
C
C                   PHASE 2.  SUM IS SMALL.
C                             SCALE TO AVOID DESTRUCTIVE UNDERFLOW.
C
   70 IF( ABS(DX(I)) .GT. CUTLO ) GO TO 75
C
C                     COMMON CODE FOR PHASES 2 AND 4.
C                     IN PHASE 4 SUM IS LARGE.  SCALE TO AVOID OVERFLOW.
C
  110 IF( ABS(DX(I)) .LE. XMAX ) GO TO 115
         SUM = ONE + SUM * (XMAX / DX(I))**2
         XMAX = ABS(DX(I))
         GO TO 200
C
  115 SUM = SUM + (DX(I)/XMAX)**2
      GO TO 200
C
C
C                  PREPARE FOR PHASE 3.
C
   75 SUM = (SUM * XMAX) * XMAX
C
C
C     FOR REAL OR D.P. SET HITEST = CUTHI/N
C     FOR COMPLEX      SET HITEST = CUTHI/(2*N)
C
   85 HITEST = CUTHI/FLOAT( N )
C
C                   PHASE 3.  SUM IS MID-RANGE.  NO SCALING.
C
      DO 95 J =I,NN,INCX
      IF(ABS(DX(J)) .GE. HITEST) GO TO 100
   95    SUM = SUM + DX(J)**2
      DNRM2 = SQRT( SUM )
      GO TO 300
C
  200 CONTINUE
      I = I + INCX
      IF ( I .LE. NN ) GO TO 20
C
C              END OF MAIN LOOP.
C
C              COMPUTE SQUARE ROOT AND ADJUST FOR SCALING.
C
      DNRM2 = XMAX * SQRT(SUM)
  300 CONTINUE
      RETURN
      END
