CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     HONDO : GSS FORTRAN
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE MOGUES
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (MXIODA=255)
      PARAMETER (MXBFN=3072)
      PARAMETER (MXATOM=128)
      PARAMETER (MXNROT=64)
      INTEGER      CSVRUN
      INTEGER      BETA
      INTEGER      BSTATE
      LOGICAL      ORDERA
      LOGICAL      ORDERB
      LOGICAL      BWRIT
      LOGICAL      DBUG
      CHARACTER*80 GSSFIL
      CHARACTER*8  ERRMSG
C#g77 ------------------------------------------
C#g77 The following character strings are now
C#g77 explitly defined:
      CHARACTER*8 TYP1,TYP2,TYP3,TYP4,TYP5,TYP6,
     1            TYP7,TYP8,TYP9,ET,SEAM,SCF,UHF,
     2            GSSMO,RUNTYP,WFNTYP,SCFTYP,TYPE
C#g77 ------------------------------------------
      COMMON/IOFILE/IR,IW,IP
      COMMON/DAFILE/IDAF,NAV,IODA(MXIODA)
      COMMON/RESTAR/NREST
      COMMON/OUTPUT/NPRINT
      COMMON/RUNOPT/RUNTYP
      COMMON/WFNOPT/WFNTYP
      COMMON/SCFOPT/SCFTYP
      COMMON/CSVOPT/CSVRUN
      COMMON/ETXPAR/NOVCAB
      COMMON/GSSPRT/PRTTOL,MPRINT
      COMMON/GSSPAR/MODGSS
      COMMON/INFOA/NAT,ICH,MUL,NUM,NX,NE,NA,NB,ZAN(MXATOM),
     1                                         C(3,MXATOM)
      DIMENSION JORDER(MXATOM)
      DIMENSION IORDER(MXBFN)
      DIMENSION IORDRA(MXBFN),IORDRB(MXBFN)
      DIMENSION LFRAG(2,MXATOM)
      DIMENSION MOROT(2,MXNROT),MOROTA(2,MXNROT),MOROTB(2,MXNROT)
      DIMENSION TYPE(9)
      DIMENSION ERRMSG(3)
      EQUIVALENCE (MOROT(1,1),MOROTA(1,1))
      EQUIVALENCE (IORDER(1),IORDRA(1))
      EQUIVALENCE (TYP1,TYPE(1)),(TYP2,TYPE(2)),(TYP3,TYPE(3)),
     1            (TYP4,TYPE(4)),(TYP5,TYPE(5)),(TYP6,TYPE(6)),
     2            (TYP7,TYPE(7)),(TYP8,TYPE(8)),(TYP9,TYPE(9))
      DATA ERRMSG /'PROGRAM ','STOP IN ','-MOGUES-'/
      DATA TYP1,TYP2,TYP3,TYP4,TYP5,TYP6,TYP7,TYP8,TYP9
     1            /'HCKGUESS','HCORE   ','STOGUESS','N31GUESS',
     2             'MOREAD  ','MOSAVED ','DZVGUESS','CONCAT  ',
     3             '        '/
      DATA MAXGSS /9/
      DATA TOLZER /1.0D-12/
      DATA PRTTHR /2.0D-01/
      DATA ZERO   /0.0D+00/
      DATA ET     /'ET      '/
      DATA SEAM   /'SEAM    '/
      DATA SCF    /'SCF     '/
      DATA UHF    /'UHF     '/
C
      DATA NGUESS /2/
      DATA NFORMT /0/
      DATA NORB   /0/
      DATA NORDER /0/
      DATA MORDER /0/
      DATA ZERTOL /0.0D+00/
      DATA NPUNCH /0/
      DATA NPFLG  /0/
      DATA BETA   /0/
      DATA BSTATE /0/
      DATA NFRAG  /0/
      DATA LFRAG  /256*0/
      DATA NROT   /0/
C
      NAMELIST /GUESS/ NGUESS,NORB,NFORMT,
     1                 NORDER,IORDER,IORDRA,IORDRB,
     2                 ZERTOL,NPUNCH,NPFLG,PRTTOL,
     3                 BETA,BSTATE,
     4                 MORDER,JORDER,NFRAG,LFRAG,
     5                 NROT,MOROT,MOROTA,MOROTB,
     6                 GSSFIL
C
C     NGUESS  = 1 FOR 'HCKGUESS'
C             = 2 FOR 'HCORE   '
C             = 3 FOR 'STOGUESS'
C             = 4 FOR 'N31GUESS'
C             = 5 FOR 'MOREAD  '
C             = 6 FOR 'MOSAVED '
C             = 7 FOR 'DZVGUESS'
C             = 8 FOR 'CONCAT  '
C
C     GSSFIL  = NAME OF THE DISK FILE WHERE TO READ THE VECTORS FROM.
C               WORKS WHEN NGUESS=5; DEFAULT IS -INPUT- FILE .
C
C     NORB    = NUMBER OF VECTORS TO BE READ IN.
C               (REQUIRED IF NGUESS=1 OR 5)
C               ALSO, NUMBER OF VECTORS TO BE PRINTED.
C
C     NFORMT = FLAG TO GIVE FORMAT FOR READING INPUT VECTORS
C               WHEN NGUESS=5, ONLY.
C               0 ... COEFFICIENTS ARE READ AS E15.8 REALS.
C               1 ... COEFFICIENTS ARE READ AS F5.2  REALS.
C
C     NORDER = FLAG TO REORDER THE ORBITALS
C              0 ... DO NOT REORDER THE MO'S. (DEFAULT)
C              1 ... REORDER THE MO'S. NEW ORDER IS GIVEN IN -IORDER-
C
C     IORDER = GIVES NEW ORDERING OF THE ORBITALS. IT IS EQUIVALENCED
C              TO -IORDRA- BELOW, AND IS INTENDED TO BE USED WHEN NO
C              DISCTINCTION BETWEEN ALPHA AND BETA ORBITALS IS NEEDED.
C
C     IORDRA = GIVES NEW ORDERING OF THE ALPHA ORBITALS, AS WHEN
C              DEALING WITH SPIN UNRESTRICTED WAVEFUNCTION.
C
C     IORDRB = GIVES NEW ORDERING OF THE BETA  ORBITALS, AS WHEN
C              DEALING WITH SPIN UNRESTRICTED WAVEFUNCTION.
C
C     MORDER = FLAG TO REORDER THE BASIS FUNCTIONS TO MATCH
C              THE CURRENT BASIS SET. ( USEFUL WHEN CALCULATING
C              SAME MOLECULE WITH DIFFERENT SYMMETRY GROUP )
C              0 ... DO NOT REORDER THE BASIS FUNCTIONS ( DEFAULT )
C              1 ... REORDER BASIS FUNCTIONS. NEW ORDER OF THE ATOMS
C                    IS GIVEN IN -JORDER- .
C     JORDER = SERIAL NUMBER OF THE ATOMS FROM THE OLD ORDER (BASIS)
C              FOR EACH ATOM IN THE CURRENT BASIS
C
C     NFRAG  = NUMBER OF FRAGMENTS FROM WHICH THE MO'S ARE TO BE
C              CONCATENATED.
C
C     LFRAG  = FOR EACH FRAGMENT, LFRAG(1, ) IS THE BASIS SET SIZE
C              FOR THE FRAGMENT,  LFRAG(2, ) IS THE NUMBER OF MO'S
C              TO BE EXTRACTED.
C
C     NROT   = FLAG TO APPLY 2*2 ROTATIONS TO ORBITALS
C
C     MOROT  = PAIR OF INDICES OF ORBITAL PAIR-WISE ROTATIONS
C              FOR ALPHA ORBITALS ( ALSO -MOROTA- )
C
C     MOROTB = PAIR OF INDICES FOR ORBITAL PAI-WISE ROTATIONS
C              FOR BETA ORBITALS
C
C     ZERTOL = TRUNCATION THRESHOLD, I.E. ALL COEFFICIENTS ARE
C              TRUNCATED BEYOND THE DECIMAL PLACE WHICH CONTRIBUTES
C              LESS THAN -ZERTOL- TO THE COEFFICIENTS.
C
C     PRTTOL = THRESHOLD FOR PRINTING VECTOR COEFFICIENTS
C
C     NPUNCH = FLAG TO PUNCH OUT THE INITIAL GUESS MO'S
C              0 ... DO NOT PUNCH ORBITALS
C              1 ...        PUNCH ORBITALS
C
C     NPFLG  = FLAG FOR DEBUG PRINTING
C              0 ... NORMAL PRINTING
C              1 ... DEBUG  PRINTING
C
C     BETA   = FLAG TO READ IN BETA-SPIN VECTORS IN -UHF- RUN
C              0 ... READ ONLY ALPHA-SPIN VECTORS (DEFAULT)
C              1 ... READ ALPHA- AND BETA-SPIN VECTORS
C
C     BSTATE = FLAG TO READ IN VECTORS FOR A B-STATE ( FOR -ET-
C              OR -SEAM- )
C              0 ... READ VECTORS FOR ONE STATE ONLY (DEFAULT)
C              1 ... READ VECTORS FOR TWO STATES
C
      DBUG=.FALSE.
C
      MAXORB=MXBFN
      DO IORB=1,MAXORB
         IORDRA(IORB)=IORB
         IORDRB(IORB)=IORB
      ENDDO
      DO IATM=1,NAT
         JORDER(IATM) = IATM
      ENDDO
      DO IROT=1,MXNROT
         MOROTA(1,IROT)=0
         MOROTA(2,IROT)=0
         MOROTB(1,IROT)=0
         MOROTB(2,IROT)=0
      ENDDO
      PRTTOL=PRTTHR
C
      DO I=1,80
         GSSFIL(I:I)=' '
      ENDDO
C
C     ----- FOR -ET- RUN , DEFAULT IS SET TO READ TWO SETS -----
C           OF VECTORS, ONE FOR THE A-STATE AND ONE FOR THE
C           B-STATE. THIS MAY BE OVERWRITTEN BY NAMELIST
C           INPUT
C
      IF(RUNTYP.EQ.ET) BSTATE=1
C
C     ----- INITIAL GUESS MATCH FROM BASIS SET -----
C
      NGUESS=MODGSS
C
C     ----- READ IN NAMELIST $GUESS -----
C
      REWIND IR
      READ(IR,GUESS,END=5,ERR=5)
    5 CONTINUE
C
C     ----- FOR -SEAM- RUN , ONE MUST READ TWO SETS OF -----
C           VECTORS, ONE FOR THE A-STATE AND ONE FOR
C           THE B-STATE
C
      IF(RUNTYP.EQ.SEAM) BSTATE=1
      BWRIT=RUNTYP.EQ.ET.OR.RUNTYP.EQ.SEAM.OR.BSTATE.NE.0
      IF(BSTATE.EQ.0) NOVCAB=1
      IF(BSTATE.NE.0) NOVCAB=0
C
C     ----- SET OTHER OPTIONS -----
C
      MPRINT=0
      IF(NPRINT.EQ.2.OR.NPFLG.NE.0) MPRINT=1
      ZERTOL= ABS(ZERTOL)
      IF(ZERTOL.LT.TOLZER) ZERTOL=ZERO
      WRITE(IW,9996) NGUESS,NORB,ZERTOL,NFORMT,BETA,BSTATE,
     1               NPFLG,NPUNCH,NORDER,MORDER,NROT,NFRAG,
     2               GSSFIL
C
      IF(BETA.NE.0) THEN
         WFNTYP=SCF
         SCFTYP=UHF
      ENDIF
C
      IF(NORDER.NE.0.AND.NORB.EQ.0) THEN
         WRITE(IW,9998)
         CALL HNDERR(3,ERRMSG)
      ENDIF
C
      IF(NORDER.NE.0) THEN
         ORDERA=.FALSE.
         DO IORB=1,NORB
            ORDERA=ORDERA.OR.IORDRA(IORB).NE.IORB
         ENDDO
         ORDERB=.FALSE.
         DO IORB=1,NORB
            ORDERB=ORDERB.OR.IORDRB(IORB).NE.IORB
         ENDDO
         IF(ORDERA.AND..NOT.ORDERB) THEN
            DO IORB=1,NORB
               IORDRB(IORB)=IORDRA(IORB)
            ENDDO
         ELSEIF(ORDERB.AND..NOT.ORDERA) THEN
            DO IORB=1,NORB
               IORDRA(IORB)=IORDRB(IORB)
            ENDDO
         ENDIF
         WRITE(IW,9995) (IORDRA(IORB),IORB=1,NORB)
         WRITE(IW,9994) (IORDRB(IORB),IORB=1,NORB)
      ENDIF
C
      IF(NGUESS.LE.0.OR.NGUESS.GT.(MAXGSS-1)) NGUESS=MAXGSS
      GSSMO=TYPE(NGUESS)
      IF(NORB.LT.0  ) NORB=0
      IF(NORB.GT.NUM) NORB=NUM
      NA=NORB
      NB=NORB
C
C     ----- FORCE -TYP8- FOR  -CSOV- RUN -----
C
      IF(CSVRUN.EQ.1) THEN
         GSSMO=TYP8
      ENDIF 
C
C     ----- FORCE -TYP6- UPON RESTART -----
C
      IF(NREST.GT.0) THEN
         GSSMO=TYP6
      ENDIF
C
C     ----- -STO- HUCKEL GUESS PROJECTED -----
C
      IF(GSSMO.NE.TYP1) GO TO 10
      CALL GSSHCK(NORB,ZERTOL)
      GO TO 100
C
C     ----- START WITH BARE NUCLEUS HAMILTONIAN MATRIX -----
C
   10 IF(GSSMO.NE.TYP2) GO TO 20
      CALL HCORE(NORB,ZERTOL)
      GO TO 100
C
C     ----- MINIMAL BASIS SET INITIAL GUESS ROUTINE -----
C
   20 IF(GSSMO.NE.TYP3) GO TO 30
      CALL GSSSTO(NORB,ZERTOL)
      GO TO 100
C
C     ----- EXTENDED BASIS SET INITIAL GUESS ROUTINE -----
C
   30 IF(GSSMO.NE.TYP4) GO TO 40
      CALL GSSN31(NORB,ZERTOL)
      GO TO 100
C
C     ----- READ MO*S FROM CARDS -----
C
   40 IF(GSSMO.NE.TYP5) GO TO 50
      CALL GSSINP(NORB,ZERTOL,NFORMT,BETA,BSTATE,BWRIT,
     1            MORDER,JORDER,GSSFIL)
      GO TO 100
C
C     ----- READ SAVED MO*S -----
C
   50 IF(GSSMO.NE.TYP6) GO TO 60
      CALL GSSDAF(NORB)
      GO TO 100
C
C     ----- -DZV- GUESS -----
C
   60 IF(GSSMO.NE.TYP7) GO TO 70
      CALL GSSDZV(NORB,ZERTOL)
      GO TO 100
C
C     ----- -CONCAT- GUESS FROM FRAGMENTS -----
C
   70 IF(GSSMO.NE.TYP8) GO TO 80
      IF(NFRAG.GT.0) THEN
         WRITE(IW,9993) (LFRAG(1,IFRAG),IFRAG=1,NFRAG)
         WRITE(IW,9992) (LFRAG(2,IFRAG),IFRAG=1,NFRAG)
      ENDIF
      CALL GSSCAT(NORB,ZERTOL,NFORMT,NFRAG,LFRAG)
      GO TO 100
C
C     ----- ERROR IN INITIAL GUESS OPTION -----
C
   80 WRITE(IW,9997) GSSMO
      CALL HNDERR(3,ERRMSG)
C
  100 CONTINUE
C
C     ----- PUNCH ORBITALS IF REQUESTED -----
C
      IF(NPUNCH.NE.0) THEN
         CALL GSSPUN(NORB)
      ENDIF
C
C     ----- REORDER THE ORBITALS -----
C
      IF(NORDER.NE.0) THEN
         IF(GSSMO.NE.TYP6) THEN
            CALL GSSORD(IORDRA,IORDRB,NORB)
         ENDIF
      ENDIF
C
C     ----- ROTATE PAIRS OF ORBITALS -----
C
      IF(NROT.NE.0) THEN
         IF(DBUG) THEN
            WRITE(IW,9991) (MOROTA(1,I),MOROTA(2,I),I=1,MXNROT)
         ENDIF
         IF(GSSMO.NE.TYP6) THEN
            CALL GSSROT(MOROTA,MOROTB,NORB)
         ENDIF
      ENDIF
C
 9998 FORMAT(' IN -MOGUES- , REORDERING OF THE MOS IS REQUESTED',/,
     1       ' BUT -NORB- .EQ. 0 . STOP')
 9997 FORMAT(/,' ERROR IN INITIAL GSSMO OPTION, GSSMO = ',A8)
 9996 FORMAT(/,' ----- NAMELIST $GUESS -----',
     1       /,10H NGUESS = ,I3,10H   NORB = ,I4,10H ZERTOL = ,E9.2,
     2         10H NFORMT = ,I3,10H   BETA = ,I2,10H BSTATE = ,I2,
     3       /,10H NPFLG  = ,I3,10H NPUNCH = ,I3,10H NORDER = ,I3,
     4         10H MORDER = ,I3,10H   NROT = ,I3,10H NFRAG  = ,I3,
     5       /,10H GSSFIL = ,1H-,A80,1H-,/)
 9995 FORMAT(16H IORDRA(IORB) = ,/,11(25I5,/))
 9994 FORMAT(16H IORDRB(IORB) = ,/,11(25I5,/))
 9993 FORMAT(16H LFRAG(1,   ) = ,/, 8(16I5,/))
 9992 FORMAT(16H LFRAG(2,   ) = ,/, 8(16I5,/))
 9991 FORMAT(' IN -MOGUESS- , -MOROTA- = ',2I5)
      RETURN
      END
      SUBROUTINE GSSOUT(V,E,LAB,M,N,NDIM)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (MXBFN=3072)
      PARAMETER (MXATOM=128)
C#g77 COMMON/IOFILE/IR,IW
      COMMON/IOFILE/IR,IW,IP
      COMMON/MOLLAB/ANAM(MXATOM),BNAM(MXATOM),BFLAB(MXBFN)
      COMMON/GSSPRT/PRTTOL,NPRINT
      DIMENSION V(NDIM,1),E(1),LAB(1)
      DIMENSION IC(5),CBF(5),C(5)
      DATA ICMAX /5/
C
      VTOL=PRTTOL
C
      DO J=1,M
         WRITE(IW,9328) J,LAB(J),E(J)
C
         II=0
         DO I=1,N
            IF( ABS(V(I,J)).GE.VTOL) THEN
               II=II+1
               IC (II)=I
               CBF(II)=BFLAB(I)
               C  (II)=V(I,J)
               IF(II.EQ.ICMAX) THEN
                  WRITE(IW,9348) (IC(IDUM),CBF(IDUM),C(IDUM),IDUM=1,II)
                  II=0
               ENDIF
            ENDIF
         ENDDO
         IF(II.GT.0) THEN
            WRITE(IW,9348) (IC(IDUM),CBF(IDUM),C(IDUM),IDUM=1,II)
         ENDIF
      ENDDO
C
      RETURN
 9328 FORMAT(/,' VEC =',I5,' SYM = ',A4,' E =',F11.5,/,1X,36(1H-))
 9348 FORMAT(5(I5,1X,A8,F8.2))
      END
      SUBROUTINE GSSORD(IORDRA,IORDRB,NORB)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (MXIODA=255)
      PARAMETER (MXATOM=128)
      COMMON/IOFILE/IR,IW,IP
      COMMON/DAFILE/IDAF,NAV,IODA(MXIODA)
      COMMON/INFOA/NAT,ICH,MUL,NUM,NX,NE,NA,NB,ZAN(MXATOM),
     1                                         C(3,MXATOM)
      COMMON/SCM/X(1)
      DIMENSION IORDRA(1),IORDRB(1)
C
      L1= NUM
      L2=(NUM*(NUM+1))/2
      L3= NUM* NUM
C
C     ----- GET CORE MEMORY -----
C
      CALL CMEM(LOADCM)
      LOCX1=LOCCM(X(1))
      LAST=L3
      NEED=LOCX1+LAST
      CALL SETC(NEED)
C
      IPASS=1
      NDAF=15
      WRITE(IW,9999) (IORDRA(I),I=1,NORB)
   10 CONTINUE
      CALL DAREAD(IDAF,IODA,X,L3,NDAF)
      DO IORB=1,NORB
         IF(IPASS.EQ.1) NUIORB=IORDRA(IORB)
         IF(IPASS.EQ.2) NUIORB=IORDRB(IORB)
         IF(NUIORB.NE.IORB) THEN
            NUI0  =(NUIORB-1)*L1
              I0  =(  IORB-1)*L1
            DO I=1,L1
               DUM=X(I0+I)
               X(I0+I)=X(NUI0+I)
               X(NUI0+I)=DUM
            ENDDO
            IF(IORB.LT.NORB) THEN
               IORB1=IORB+1
               DO I=IORB1,NORB
                  IF(IPASS.EQ.1.AND.IORDRA(I).EQ.IORB) IORDRA(I)=NUIORB
                  IF(IPASS.EQ.2.AND.IORDRB(I).EQ.IORB) IORDRB(I)=NUIORB
               ENDDO
            ENDIF
         ENDIF
      ENDDO
      CALL DAWRIT(IDAF,IODA,X,L3,NDAF,NAV)
C
      IF(IPASS.EQ.2) GO TO 20
      IPASS=2
      NDAF=19
      WRITE(IW,9998) (IORDRB(I),I=1,NORB)
      GO TO 10
   20 CONTINUE
C
C     ----- RESET CORE MEMORY -----
C
      CALL CMEM(NGOTCM)
      IF(NGOTCM.NE.LOADCM) CALL SETC(LOADCM)
      RETURN
 9999 FORMAT(/,10X,31H NEW ORDER OF ALPHA ORBITALS = ,/,10X,31(1H-),
     1       /,11(25I5,/))
 9998 FORMAT(/,10X,31H NEW ORDER OF BETA  ORBITALS = ,/,10X,31(1H-),
     1       /,11(25I5,/))
      END
      SUBROUTINE GSSROT(MOROTA,MOROTB,NORB)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (MXIODA=255)
      PARAMETER (MXATOM=128)
      PARAMETER (MXNROT=64)
      LOGICAL DBUG
      CHARACTER*24 ERRMSG
      COMMON/IOFILE/IR,IW,IP
      COMMON/DAFILE/IDAF,NAV,IODA(MXIODA)
      COMMON/INFOA/NAT,ICH,MUL,NUM,NX,NE,NA,NB,ZAN(MXATOM),
     1                                         C(3,MXATOM)
      COMMON/SCM/X(1)
      DIMENSION MOROTA(2,1),MOROTB(2,1)
      DATA ERRMSG /'PROGRAM STOP IN -GSSROT-'/
      DATA ONE    /1.0D+00/
      DATA TWO    /2.0D+00/
C
      L1= NUM
      L2=(NUM*(NUM+1))/2
      L3= NUM* NUM
C
C     ----- GET CORE MEMORY -----
C
      CALL CMEM(LOADCM)
      LOCX1=LOCCM(X(1))
      LAST=L3
      NEED=LOCX1+LAST
      CALL SETC(NEED)
C
      DBUG=.FALSE.
      ROT=ONE/SQRT(TWO)
      C11= ROT
      C21= ROT
      C12=-ROT
      C22= ROT
C
      NROTA=0
      DO IROT=1,MXNROT
         IF(MOROTA(1,IROT).NE.0.AND.MOROTA(2,IROT).NE.0) THEN
            NROTA=NROTA+1
         ELSE
            GO TO 10
         ENDIF
      ENDDO
   10 CONTINUE
      IF(NROTA.NE.0) THEN
         DO IROT=1,NROTA
            IORB=MOROTA(1,IROT)
            JORB=MOROTA(2,IROT)
            DO JROT=1,NROTA
               IF(JROT.NE.IROT) THEN
               IF(MOROTA(1,JROT).EQ.IORB.OR.MOROTA(1,JROT).EQ.JORB.OR.
     1            MOROTA(2,JROT).EQ.IORB.OR.MOROTA(2,JROT).EQ.JORB) THEN
                  WRITE(IW,9997)
                  CALL HNDERR(3,ERRMSG)
               ENDIF
               ENDIF
            ENDDO
         ENDDO
      ENDIF
C
      NROTB=0
      DO IROT=1,MXNROT
         IF(MOROTB(1,IROT).NE.0.AND.MOROTB(2,IROT).NE.0) THEN
            NROTB=NROTB+1
         ELSE
            GO TO 20
         ENDIF
      ENDDO
   20 CONTINUE
      IF(NROTB.NE.0) THEN
         DO IROT=1,NROTB
            IORB=MOROTB(1,IROT)
            JORB=MOROTB(2,IROT)
            DO JROT=1,NROTB
               IF(JROT.NE.IROT) THEN
               IF(MOROTB(1,JROT).EQ.IORB.OR.MOROTB(1,JROT).EQ.JORB.OR.
     1            MOROTB(2,JROT).EQ.IORB.OR.MOROTB(2,JROT).EQ.JORB) THEN
                  WRITE(IW,9997)
                  CALL HNDERR(3,ERRMSG)
               ENDIF
               ENDIF
            ENDDO
         ENDDO
      ENDIF
C
      IF(NROTA.EQ.0.AND.NROTB.EQ.0) THEN
         WRITE(IW,9996)
         RETURN
      ENDIF
C
      IPASS=1
      NDAF=15
      NROT=NROTA
  100 CONTINUE
      IF(NROT.GT.0) THEN
         CALL DAREAD(IDAF,IODA,X,L3,NDAF)
         IF(IPASS.EQ.1) THEN
            WRITE(IW,9999) (MOROTA(1,I),MOROTA(2,I),I=1,NROTA)
         ELSE
            WRITE(IW,9998) (MOROTB(1,I),MOROTB(2,I),I=1,NROTB)
         ENDIF
         DO IROT=1,NROT
            IF(IPASS.EQ.1) IORB=MOROTA(1,IROT)
            IF(IPASS.EQ.1) JORB=MOROTA(2,IROT)
            IF(IPASS.EQ.2) IORB=MOROTB(1,IROT)
            IF(IPASS.EQ.2) JORB=MOROTB(2,IROT)
            DO I=1,L1
               II=I+L1*(IORB-1)
               IJ=I+L1*(JORB-1)
               XII=X(II)
               XIJ=X(IJ)
               YII=C11*XII+C21*XIJ
               YIJ=C12*XII+C22*XIJ
               X(II)=YII
               X(IJ)=YIJ
            ENDDO
         ENDDO
         CALL DAWRIT(IDAF,IODA,X,L3,NDAF,NAV)
         IF(DBUG) THEN
            CALL PRSQ(X,NORB,L1,L1)
         ENDIF
      ENDIF
C
      IF(IPASS.EQ.2) GO TO 110
         IPASS=2
         NDAF=19
         NROT=NROTB
         GO TO 100
  110 CONTINUE
C
C     ----- RESET CORE MEMORY -----
C
      CALL CMEM(NGOTCM)
      IF(NGOTCM.NE.LOADCM) CALL SETC(LOADCM)
      RETURN
 9999 FORMAT(/,10X,31H ROTATIONS OF ALPHA ORBITALS = ,/,10X,31(1H-),
     1       /,11(6(1H(,I5,1H,,I5,1H)),/))
 9998 FORMAT(/,10X,31H ROTATIONS OF BETA  ORBITALS = ,/,10X,31(1H-),
     1       /,11(6(1H(,I5,1H,,I5,1H)),/))
 9997 FORMAT(' INDICES OF ORBITALS FOR PAIR-WISE ROTATIONS',
     1       ' ARE WRONG. STOP.')
 9996 FORMAT(' NO PAIR-WISE ORBITAL ROTATION PARAMETERS SPECIFIED.')
      END
      SUBROUTINE GSSWT(V,D,E,L1,L2,L3,IDAR)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (MXIODA=255)
      COMMON/IOFILE/IR,IW,IP
      COMMON/DAFILE/IDAF,NAV,IODA(MXIODA)
      DIMENSION D(1),V(1),E(1)
      CALL DAWRIT(IDAF,IODA,V,L3,IDAR  ,NAV)
      CALL DAWRIT(IDAF,IODA,D,L2,IDAR+1,NAV)
      CALL DAWRIT(IDAF,IODA,E,L1,IDAR+2,NAV)
      RETURN
      END
      SUBROUTINE GSSRD(V,D,E,L1,L2,L3,IDAR)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (MXIODA=255)
      COMMON/IOFILE/IR,IW,IP
      COMMON/DAFILE/IDAF,NAV,IODA(MXIODA)
      DIMENSION V(1),D(1),E(1)
      CALL DAREAD(IDAF,IODA,V,L3,IDAR  )
      CALL DAREAD(IDAF,IODA,D,L2,IDAR+1)
      CALL DAREAD(IDAF,IODA,E,L1,IDAR+2)
      RETURN
      END
      SUBROUTINE GSSHCK(NOC,ZERTOL)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*8 ERRMSG
      COMMON/IOFILE/IR,IW,IP
      DIMENSION ERRMSG(3)
      DATA ERRMSG     /'PROGRAM ','STOP IN ','-GSSHCK-'/
C
      WRITE(IW,9999)
      CALL HNDERR(3,ERRMSG)
      RETURN
 9999 FORMAT(' INITIAL GUESS -GSSHCK- NOT AVAILABLE YET. STOP')
      END
      SUBROUTINE HCORE(NOC,ZERTOL)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (MXIODA=255)
      PARAMETER (MXATOM=128)
      CHARACTER*8 ERRMSG
      LOGICAL OUT
      COMMON/IOFILE/IR,IW,IP
      COMMON/DAFILE/IDAF,NAV,IODA(MXIODA)
      COMMON/GSSPRT/PRTTOL,NPRINT
      COMMON/INFOA/NAT,ICH,MUL,NUM,NX,NE,NA,NB,ZAN(MXATOM),
     1                                         C(3,MXATOM)
      COMMON/IJPAIR/IA(1)
      COMMON/SCM/X(1)
      DIMENSION ERRMSG(3)
      DATA ERRMSG     /'PROGRAM ','STOP IN ','-HCORE -'/
      DATA SMALL,ZERO /1.0D-09,0.0D+00/
      DATA TOL        /2.0D+09/
C
      WRITE(IW,9999)
      OUT=NPRINT.NE.0
      L1= NUM
      L2=(NUM*(NUM+1))/2
      L3= NUM*NUM
C
C     ----- SET POINTERS FOR PARTITIONING OF CORE -----
C
      I10=     1
      I20=I10+L2
      I21=I10+L3
      I30=I20+L2
      I40=I30+L2
      I41=I30+L3
      I50=I40+L2
      I51=I50+L1
      I60=I50+L2
C
C     ----- GET CORE MEMORY -----
C
      CALL CMEM(LOADCM)
      LAST=I60-1
      LOC10=LOCCM(X(I10))
      NEED=LOC10+LAST
      IF(OUT) CALL NEEDCM(LAST,NEED)
      CALL SETC(NEED)
C
C     ----- GET CANONICAL ORTHONORMAL VECTORS -----
C
      CALL DAREAD(IDAF,IODA,X(I10),L2,12)
      IF(OUT) WRITE(IW,8889)
      IF(OUT) CALL PRTRL(X(I10),L1)
      CALL QMTCAN(X(I10),X(I20),X(I30),X(I41),X(I50),IA,L0,L1,L3,L1)
      IF(OUT) WRITE(IW,8888)
      IF(OUT) CALL PREVL(X(I30),X(I41),L0,L1,L1)
C
C     ----- READ IN BARE NUCLEUS HAMILTONIAN MATRIX -----
C
      CALL DAREAD(IDAF,IODA,X(I10),L2,11)
C
C     ----- FOCK TRANSFORMATION H= Q*H0*Q -----
C
      CALL TFTR(X(I20),X(I10),X(I30),X(I41),IA,L0,L1,L1)
C
C     ----- DIAGONALIZE H MATRIX -----
C
      CALL DIASYM(X(I20),X(I30),X(I41),IA,L0,L0,L1)
C
C     ----- BACK-TRANSFORM THE EIGENVECTORS -----
C
      CALL DAREAD(IDAF,IODA,X(I10),L3,13)
      CALL TFSQB(X(I30),X(I10),X(I21),L0,L0,L1,L1)
C
      IF(ZERTOL.NE.ZERO) THEN
         NDUM=NUM*L0
         DO I=1,NDUM
            DUM=X(I-1+I30)/ZERTOL
            IF( ABS(DUM).GT.TOL) THEN
               WRITE(IW,7777) ZERTOL
               CALL HNDERR(3,ERRMSG)
            ENDIF
            IDUM=IDINT(DUM)
            X(I-1+I30)=DBLE(IDUM)*ZERTOL
         ENDDO
      ENDIF
C
      NDUM=NUM*L0
      DO I=1,NDUM
         DUM=X(I-1+I30)
         IF( ABS(DUM).LE.SMALL) DUM=ZERO
         X(I-1+I30)=DUM
      ENDDO
C
C     ----- WRITE MO'S AS -ALPHA- AND -BETA- SETS -----
C
      CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3,15)
      CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3,19)
C
C     ----- ASSIGN A SYMMETRY REPRESENTATION LABEL TO MO'S -----
C
      CALL DAREAD(IDAF,IODA,X(I50),L2,12)
      CALL DAREAD(IDAF,IODA,X(I10),L3,13)
      CALL SYMMOS(X(I50),X(I50),X(I50),X(I10),X(I50),X(I30),X(I21),
     1            IA,L0,L1,L0,L1)
      IF(     OUT.AND.NOC.GT.0)
     1 CALL PREVLS(X(I30),X(I41),X(I50),NOC,L1,L1)
      IF(.NOT.OUT.AND.NOC.GT.0)
     1 CALL GSSOUT(X(I30),X(I41),X(I50),NOC,L1,L1)
C
C     ----- RESET CORE MEMORY -----
C
      CALL CMEM(NGOTCM)
      IF(NGOTCM.NE.LOADCM) CALL SETC(LOADCM)
      RETURN
 9999 FORMAT(/,' INITIAL GUESS ORBITALS GENERATED FROM BARE NUCLEUS',
     1         ' HAMILTONIAN',/)
 8889 FORMAT(/,1X,'OVERLAP MATRIX',/,1X,14(1H-))
 8888 FORMAT(/,1X,'CANONICAL ORTHONORMAL ORBITALS',/,1X,30(1H-))
 7777 FORMAT(' IN - HCORE-, COEFFICIENT IS TOO LARGE TO BE',/,
     1 ' TRUNCATED WITH -ZERTOL- = ',E10.5,' INCREASE -ZERTOL-',/,
     2 ' OR SET IT TO EXACT ZERO.')
      END
      SUBROUTINE HUCKEL(ENEG)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION ENEG(18,7)
      DATA ZERO /0.0D+00/
C
C    ---- PARAMETERIZE AN EXTENDED HUCKEL TYPE CALCULATION ----
C
      DO I=1,18
         DO J=1,7
            ENEG(I,J) = ZERO
         ENDDO
      ENDDO
C
C  FILL ENEG WITH SCF ORBITAL ENERGIES
C  (CLEMENTI AND ROETTI, AT.NUC.DATA.TABLES VOL.14)
C
C  ENEG(NUCZ,ISHELL)
C   ISHELL SHELL
C     1      1S
C     2      2S
C     3      2P
C     4      3S
C     5      3P
C     6      4S
C     7      4P
C
C     ----- H , HE -----
C
      ENEG( 1,1) = -0.5D+00
      ENEG( 2,1) = -0.918D+00
C
C     ----- LI - BE ( GUESS P ENERGY ) -----
C
      ENEG( 3,1) = -2.48D+00
      ENEG( 3,2) = -0.196D+00
      ENEG( 3,3) = -0.13D+00
      ENEG( 4,1) = -4.73D+00
      ENEG( 4,2) = -0.309D+00
      ENEG( 4,3) = -0.19D+00
C
C     ----- B - NE -----
C
      ENEG( 5,1) = -7.70D+00
      ENEG( 5,2) = -0.495D+00
      ENEG( 5,3) = -0.310D+00
      ENEG( 6,1) = -11.3D+00
      ENEG( 6,2) = -0.706D+00
      ENEG( 6,3) = -0.433D+00
      ENEG( 7,1) = -15.6D+00
      ENEG( 7,2) = -0.945D+00
      ENEG( 7,3) = -0.568D+00
      ENEG( 8,1) = -20.7D+00
      ENEG( 8,2) = -1.244D+00
      ENEG( 8,3) = -0.632D+00
      ENEG( 9,1) = -26.4D+00
      ENEG( 9,2) = -1.573D+00
      ENEG( 9,3) = -0.730D+00
      ENEG(10,1) = -32.8D+00
      ENEG(10,2) = -1.93D+00
      ENEG(10,3) = -0.850D+00
C
C     ----- NA - MG ( GUESS P ENERGY ) -----
C
      ENEG(11,1) = -40.5D+00
      ENEG(11,2) = -2.80D+00
      ENEG(11,3) = -1.52D+00
      ENEG(11,4) = -0.182D+00
      ENEG(11,5) = -0.12D+00
      ENEG(12,1) = -49.0D+00
      ENEG(12,2) = -3.77D+00
      ENEG(12,3) = -2.28D+00
      ENEG(12,4) = -0.253D+00
      ENEG(12,5) = -0.16D+00
C
C     ----- AL - AR -----
C
      ENEG(13,1) = -58.5D+00
      ENEG(13,2) = -4.91D+00
      ENEG(13,3) = -3.22D+00
      ENEG(13,4) = -0.393D+00
      ENEG(13,5) = -0.210D+00
      ENEG(14,1) = -68.8D+00
      ENEG(14,2) = -6.16D+00
      ENEG(14,3) = -4.26D+00
      ENEG(14,4) = -0.540D+00
      ENEG(14,5) = -0.297D+00
      ENEG(15,1) = -80.0D+00
      ENEG(15,2) = -7.51D+00
      ENEG(15,3) = -5.40D+00
      ENEG(15,4) = -0.696D+00
      ENEG(15,5) = -0.392D+00
      ENEG(16,1) = -92.0D+00
      ENEG(16,2) = -9.00D+00
      ENEG(16,3) = -6.68D+00
      ENEG(16,4) = -0.880D+00
      ENEG(16,5) = -0.437D+00
      ENEG(17,1) = -104.0D+00
      ENEG(17,2) = -10.6D+00
      ENEG(17,3) = -8.07D+00
      ENEG(17,4) = -1.073D+00
      ENEG(17,5) = -0.506D+00
      ENEG(18,1) = -118.6D+00
      ENEG(18,2) = -12.3D+00
      ENEG(18,3) = -9.57D+00
      ENEG(18,4) = -1.278D+00
      ENEG(18,5) = -0.591D+00
C
C     THE VALENCE ATOMIC ORBITAL ENERGIES ARE NOT GOOD PARAMETERS.
C     THE GAUSSIAN-XX PROGRAM INITIAL GUESS ROUTINES USE NUMBERS
C     WHICH WORK BETTER, AND WERE OBTAINED FROM EXPERIENCE.
C     THE NUMBERS USED IN GAUSS-XX ARE APPROXIMATELY RELATED
C     TO THE ATOMIC ENERGIES BY THE FOLLOWING FACTORS.
C
      ENEG(1,1) = -0.537D+00
      ENEG(2,1) = -0.735D+00
      DO I=3,10
         ENEG(I,2) = 2.0D+00 * ENEG(I,2)
         ENEG(I,3) = 0.7D+00 * ENEG(I,3)
      ENDDO
C
C     FOR THE SECOND ROW, GAUSS-XX USES 2*2S, 1*2P, 2.2*3S, 2.3*3P
C     THIS DOES NOT PREDICT THE CORRECT HOMO-LUMO FOR SIH2.
C
      DO I=11,18
         ENEG(I,2) = 2.0D+00 * ENEG(I,2)
         ENEG(I,4) = 4.0D+00 * ENEG(I,4)
         ENEG(I,5) = 2.0D+00 * ENEG(I,5)
      ENDDO
      RETURN
      END
      SUBROUTINE GSSSTO(NOC,ZERTOL)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (MXIODA=255)
      PARAMETER (MXATOM=128)
      PARAMETER (MXPRIM=2048)
      PARAMETER (MXSHEL=512)
      CHARACTER*8 ERRMSG
      REAL ATNUM
      LOGICAL OUT
      COMMON/IOFILE/IR,IW,IP
      COMMON/DAFILE/IDAF,NAV,IODA(MXIODA)
      COMMON/GSSPRT/PRTTOL,NPRINT
      COMMON/IJPAIR/IA(1)
      COMMON/INFOA/NAT,ICH,MUL,NUM,NX,NE,NA,NB,ZAN(MXATOM),
     1                                         C(3,MXATOM)
      COMMON/NSHEL/
     1EX(MXPRIM),CS(MXPRIM),CP(MXPRIM),CD(MXPRIM),CF(MXPRIM),CG(MXPRIM),
     1KSTART(MXSHEL),KATOM(MXSHEL),KTYPE(MXSHEL),KNG(MXSHEL),
     2KLOC(MXSHEL),KMIN(MXSHEL),KMAX(MXSHEL),NSHELL
      COMMON/SCM/X(1)
      DIMENSION IULIM(MXATOM),LLIM(MXATOM),ENEG(18,7)
      DIMENSION ERRMSG(3)
      DATA ERRMSG       /'PROGRAM ','STOP IN ','-GSSSTO-'/
      DATA PT005,PT0001 /0.005D+00,0.0001D+00/
      DATA SCALE        /0.875D+00/
      DATA SMALL,ZERO   /1.0D-09,0.0D+00/
      DATA TOL          /2.0D+09/
C
      WRITE(IW,9999)
      OUT=NPRINT.NE.0
      L1= NUM
      L2=(NUM*(NUM+1))/2
      L3= NUM*NUM
C
C     ----- SET POINTERS FOR PARTITIONING OF CORE -----
C
      I10=     1
      I20=I10+L2
      I21=I10+L3
      I30=I20+L2
      I40=I30+L2
      I41=I30+L3
      I50=I40+L2
      I51=I50+L1
      I60=I50+L2
C
C     ----- GET CORE MEMORY -----
C
      CALL CMEM(LOADCM)
      LAST=I60-1
      LOC10=LOCCM(X(I10))
      NEED=LOC10+LAST
      IF(OUT) CALL NEEDCM(LAST,NEED)
      CALL SETC(NEED)
C
C     ----- NOT AVAILABLE FOR NUCZ > 18 -----
C
      DO I=1,NAT
         ATNUM=ZAN(I)
         NUCZ=IFIX(ATNUM)
         IF(NUCZ.GT.18) THEN
           WRITE(IW,9998)
           CALL HNDERR(3,ERRMSG)
         ENDIF
      ENDDO
C
C
C     ----- MINIMAL BASIS SET INITIAL GUESS ROUTINE -----
C           ENEG(I,J) ARE THE DIAGONAL ELEMENTS OF
C           THE HUCKEL HAMILTONIAN IN ATOMIC UNITS.
C     I = ATOMIC NUMBER
C     J = 1   1S ORBITAL
C     J = 2   2S ORBITAL
C     J = 3   2P ORBITAL
C     J = 4   3S ORBITAL
C     J = 5   3P ORBITAL
C     J = 6   4S ORBITAL
C     J = 7   4P ORBITAL
C
      CALL HUCKEL(ENEG)
C
C     ----- SET IULIM AND LLIM -----
C
      DO I=1,NAT
          LLIM(I)=NUM+1
         IULIM(I)=0
         DO J=1,NSHELL
            IF(KATOM(J).EQ.I) THEN
                LLIM(I)=MIN( LLIM(I),KLOC(J)                )
               IULIM(I)=MAX(IULIM(I),KLOC(J)+KMAX(J)-KMIN(J))
            ENDIF
         ENDDO
      ENDDO
C
C     ----- GET CANONICAL ORTHONORMAL VECTORS -----
C
      CALL DAREAD(IDAF,IODA,X(I10),L2,12)
      IF(OUT) WRITE(IW,8889)
      IF(OUT) CALL PRTRL(X(I10),L1)
      CALL QMTCAN(X(I10),X(I20),X(I30),X(I41),X(I50),IA,L0,L1,L3,L1)
      IF(OUT) WRITE(IW,8888)
      IF(OUT) CALL PREVL(X(I30),X(I41),L0,L1,L1)
C
C     ----- READ IN OVERLAP MATRIX AND FORM HUCKEL MATRIX -----
C
      CALL DAREAD(IDAF,IODA,X(I10),L2,12)
      DO 140 I=1,NAT
      ATNUM=ZAN(I)
      NUCZ =IFIX(ATNUM)
      IL   =LLIM(I)
      IU   =IULIM(I)
      NEXT =IL
C
C     ----- OFF NUCLEI FUNCTIONS -----
C
      IF(NUCZ.EQ.0) GO TO 130
C
C     ----- H , HE -----
C
      IF(NUCZ.GT.2) GO TO 110
      IL0=IA(IL)+IL
      X(IL0)=ENEG(NUCZ,1)
      NEXT=IL+1
      GO TO 130
C
C     ----- LI , BE -----
C
  110 CONTINUE
      IF(NUCZ.GT.4) GO TO 115
      IL0=IA(IL)+IL
      IL1=IA(IL+1)+IL+1
      X(IL0)=ENEG(NUCZ,1)
      X(IL1)=ENEG(NUCZ,2)
      NEXT=IL+2
      GO TO 130
C
C     ----- B - NE -----
C
  115 CONTINUE
      IF(NUCZ.GT.10) GO TO 120
      IL0=IA(IL)+IL
      IL1=IA(IL+1)+IL+1
      IL2=IA(IL+2)+IL+2
      IL3=IA(IL+3)+IL+3
      IL4=IA(IL+4)+IL+4
      X(IL0)=ENEG(NUCZ,1)
      X(IL1)=ENEG(NUCZ,2)
      X(IL2)=ENEG(NUCZ,3)
      X(IL3)=ENEG(NUCZ,3)
      X(IL4)=ENEG(NUCZ,3)
      NEXT=IL+5
      GO TO 130
C
C     ----- NA , MG -----
C
  120 CONTINUE
      IF(NUCZ.GT.12) GO TO 125
      IL0=IA(IL)+IL
      IL1=IA(IL+1)+IL+1
      IL2=IA(IL+2)+IL+2
      IL3=IA(IL+3)+IL+3
      IL4=IA(IL+4)+IL+4
      IL5=IA(IL+5)+IL+5
      X(IL0)=ENEG(NUCZ,1)
      X(IL1)=ENEG(NUCZ,2)
      X(IL2)=ENEG(NUCZ,3)
      X(IL3)=ENEG(NUCZ,3)
      X(IL4)=ENEG(NUCZ,3)
      X(IL5)=ENEG(NUCZ,4)
      NEXT=IL+6
      GO TO 130
C
C     ----- AL - AR -----
C
  125 CONTINUE
      IL0=IA(IL)+IL
      IL1=IA(IL+1)+IL+1
      IL2=IA(IL+2)+IL+2
      IL3=IA(IL+3)+IL+3
      IL4=IA(IL+4)+IL+4
      IL5=IA(IL+5)+IL+5
      IL6=IA(IL+6)+IL+6
      IL7=IA(IL+7)+IL+7
      IL8=IA(IL+8)+IL+8
      X(IL0)=ENEG(NUCZ,1)
      X(IL1)=ENEG(NUCZ,2)
      X(IL2)=ENEG(NUCZ,3)
      X(IL3)=ENEG(NUCZ,3)
      X(IL4)=ENEG(NUCZ,3)
      X(IL5)=ENEG(NUCZ,4)
      X(IL6)=ENEG(NUCZ,5)
      X(IL7)=ENEG(NUCZ,5)
      X(IL8)=ENEG(NUCZ,5)
      NEXT=IL+9
C
C     ----- BOND , RYDBERG , OR POLARIZATION FUNCTIONS -----
C           TWEAK AVOIDS DEGENERACY PROBLEMS, EXCEPT
C           FOR SYMMETRY EQUIVALENT BASIS FUNCTIONS.
C
  130 CONTINUE
      BITSY=-PT005
      TWEAK=BITSY * PT0001
      IF(NEXT.GT.IU) GO TO 140
      K=0
      DO 135 J=NEXT,IU
      K=K+1
      LOC=IA(J)+J
      X(LOC)=BITSY + DBLE( 10 * NUCZ + K ) * TWEAK
  135 CONTINUE
C
  140 CONTINUE
C
C     ----- FIX UP THE OFF-DIAGONAL ELEMENTS -----
C
      IF(NUM.GT.1) THEN
         DO I=2,NUM
            DO J=1,I-1
               IJ=IA(I)+J
               II=IA(I)+I
               JJ=IA(J)+J
               X(IJ)=X(IJ)*(X(II)+X(JJ))*SCALE
            ENDDO
         ENDDO
      ENDIF
C
C     ----- FOCK TRANSFORMATION -----
C
      CALL TFTR(X(I20),X(I10),X(I30),X(I41),IA,L0,L1,L1)
C
C     ----- DIAGONALIZE H MATRIX -----
C
      CALL DIASYM(X(I20),X(I30),X(I41),IA,L0,L0,L1)
C
C     ----- BACK-TRANSFORM THE EIGENVECTORS -----
C
      CALL DAREAD(IDAF,IODA,X(I10),L3,13)
      CALL TFSQB(X(I30),X(I10),X(I21),L0,L0,L1,L1)
C
      IF(ZERTOL.GT.ZERO) THEN
         NDUM=NUM*L0
         DO I=1,NDUM
            DUM=X(I-1+I30)/ZERTOL
            IF( ABS(DUM).GT.TOL) THEN
               WRITE(IW,7777) ZERTOL
               CALL HNDERR(3,ERRMSG)
            ENDIF
            IDUM=IDINT(DUM)
            X(I-1+I30)=DBLE(IDUM)*ZERTOL
         ENDDO
      ENDIF
C
      NDUM=NUM*L0
      DO I=1,NDUM
         DUM=X(I-1+I30)
         IF( ABS(DUM).LE.SMALL) DUM=ZERO
         X(I-1+I30)=DUM
      ENDDO
C
C     ----- WRITE MO'S AS -ALPHA- AND -BETA- SETS -----
C
      CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3,15)
      CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3,19)
C
C     ----- ASSIGN A SYMMETRY REPRESENTATION LABEL TO MO'S -----
C
      CALL DAREAD(IDAF,IODA,X(I50),L2,12)
      CALL DAREAD(IDAF,IODA,X(I10),L3,13)
      CALL SYMMOS(X(I50),X(I50),X(I50),X(I10),X(I50),X(I30),X(I21),
     1            IA,L0,L1,L0,L1)
      IF(     OUT.AND.NOC.GT.0)
     1 CALL PREVLS(X(I30),X(I41),X(I50),NOC,L1,L1)
      IF(.NOT.OUT.AND.NOC.GT.0)
     1 CALL GSSOUT(X(I30),X(I41),X(I50),NOC,L1,L1)
C
C     ----- RESET CORE MEMORY -----
C
      CALL CMEM(NGOTCM)
      IF(NGOTCM.NE.LOADCM) CALL SETC(LOADCM)
      RETURN
 9999 FORMAT(/,' INITIAL GUESS ORBITALS GENERATED WITH -STO-',
     1         ' BASIS SET INITIAL GUESS ROUTINE',/)
 9998 FORMAT(  ' -GSSSTO- NOT AVAILABLE FOR ATOMIC Z > 18 . STOP.')
 8889 FORMAT(/,1X,'OVERLAP MATRIX',/,1X,14(1H-))
 8888 FORMAT(/,1X,'CANONICAL ORTHONORMAL ORBITALS',/,1X,30(1H-))
 7777 FORMAT(  ' IN -GSSSTO-, COEFFICIENT IS TOO LARGE TO BE',/,
     1 ' TRUNCATED WITH -ZERTOL- = ',E10.5,' INCREASE -ZERTOL-',/,
     2 ' OR SET IT TO EXACT ZERO.')
      END
      SUBROUTINE GSSN31(NOC,ZERTOL)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (MXIODA=255)
      PARAMETER (MXATOM=128)
      PARAMETER (MXPRIM=2048)
      PARAMETER (MXSHEL=512)
      CHARACTER*8 ERRMSG
      REAL ATNUM
      LOGICAL OUT
      COMMON/IOFILE/IR,IW,IP
      COMMON/DAFILE/IDAF,NAV,IODA(MXIODA)
      COMMON/GSSPRT/PRTTOL,NPRINT
      COMMON/INFOA/NAT,ICH,MUL,NUM,NX,NE,NA,NB,ZAN(MXATOM),
     1                                         C(3,MXATOM)
      COMMON/NSHEL/
     1EX(MXPRIM),CS(MXPRIM),CP(MXPRIM),CD(MXPRIM),CF(MXPRIM),CG(MXPRIM),
     1KSTART(MXSHEL),KATOM(MXSHEL),KTYPE(MXSHEL),KNG(MXSHEL),
     2KLOC(MXSHEL),KMIN(MXSHEL),KMAX(MXSHEL),NSHELL
      COMMON/IJPAIR/IA(1)
      COMMON/SCM/X(1)
      DIMENSION IULIM(MXATOM),LLIM(MXATOM),ENEG(18,7)
      DIMENSION ERRMSG(3)
      DATA ERRMSG       /'PROGRAM ','STOP IN ','-GSSN31-'/
      DATA PT005,PT0001 /0.005D+00,0.0001D+00/
      DATA PT5          /0.5D+00/
      DATA SCALE        /0.875D+00/
      DATA SMALL,ZERO   /1.0D-09,0.0D+00/
      DATA TOL          /2.0D+09/
C
      WRITE(IW,9999)
      OUT=NPRINT.NE.0
      L1= NUM
      L2=(NUM*(NUM+1))/2
      L3= NUM*NUM
C
C     ----- SET POINTERS FOR PARTITIONING OF CORE -----
C
      I10=     1
      I20=I10+L2
      I21=I10+L3
      I30=I20+L2
      I40=I30+L2
      I41=I30+L3
      I50=I40+L2
      I51=I50+L1
      I60=I50+L2
C
C     ----- GET CORE MEMORY -----
C
      CALL CMEM(LOADCM)
      LAST=I60-1
      LOC10=LOCCM(X(I10))
      NEED=LOC10+LAST
      IF(OUT) CALL NEEDCM(LAST,NEED)
      CALL SETC(NEED)
C
C     ----- NOT AVAILABLE FOR NUCZ > 18 -----
C
      DO I=1,NAT
         ATNUM=ZAN(I)
         NUCZ=IFIX(ATNUM)
         IF(NUCZ.GT.18) THEN
           WRITE(IW,9998)
           CALL HNDERR(3,ERRMSG)
         ENDIF
      ENDDO
C
C     ----- EXTENDED BASIS SET INITIAL GUESS ROUTINE -----
C           THIS PROGRAM WILL HANDLE EXTENDED BASIS SETS
C           IN WHICH THE ADDITIONAL FUNCTIONS ARE OF THE
C           TYPE (N+1)S, (N+1)P WHERE N IS THE PRINCIPAL
C           QUANTUM NUMBER.
C
C           ENEG(I,J) ARE THE DIAGONAL ELEMENTS OF THE HUCKEL
C           HAMILTONIAN IN ATOMIC UNITS.
C     I = ATOMIC NUMBER
C     J = 1   1S ORBITAL
C     J = 2   2S ORBITAL
C     J = 3   2P ORBITAL
C     J = 4   3S ORBITAL
C     J = 5   3P ORBITAL
C     J = 6   4S ORBITAL
C     J = 7   4P ORBITAL
C
      CALL HUCKEL(ENEG)
C
      DO I=1,2
         ENEG(I,1)=ENEG(I,1)*PT5
         ENEG(I,2)=ENEG(I,1)
      ENDDO
      DO I=3,10
         ENEG(I,2)=ENEG(I,2)*PT5
         ENEG(I,3)=ENEG(I,3)*PT5
         ENEG(I,4)=ENEG(I,2)
         ENEG(I,5)=ENEG(I,3)
      ENDDO
      DO I=11,18
         ENEG(I,4)=ENEG(I,4)*PT5
         ENEG(I,5)=ENEG(I,5)*PT5
         ENEG(I,6)=ENEG(I,4)
         ENEG(I,7)=ENEG(I,5)
      ENDDO
C
C     ----- SET IULIM AND LLIM -----
C
      DO I=1,NAT
          LLIM(I)=NUM+1
         IULIM(I)=0
         DO J=1,NSHELL
            IF(KATOM(J).EQ.I) THEN
                LLIM(I)=MIN( LLIM(I),KLOC(J)                )
               IULIM(I)=MAX(IULIM(I),KLOC(J)+KMAX(J)-KMIN(J))
            ENDIF
         ENDDO
      ENDDO
C
C     ----- GET CANONICAL ORTHONORMAL VECTORS -----
C
      CALL DAREAD(IDAF,IODA,X(I10),L2,12)
      IF(OUT) WRITE(IW,8889)
      IF(OUT) CALL PRTRL(X(I10),L1)
      CALL QMTCAN(X(I10),X(I20),X(I30),X(I41),X(I50),IA,L0,L1,L3,L1)
      IF(OUT) WRITE(IW,8888)
      IF(OUT) CALL PREVL(X(I30),X(I41),L0,L1,L1)
C
C     ----- READ IN THE OVERLAP MATRIX AND FORM HUCKEL MATRIX -----
C
      CALL DAREAD(IDAF,IODA,X(I10),L2,12)
      DO 140 I=1,NAT
      ATNUM=ZAN(I)
      NUCZ =IFIX(ATNUM)
      IL   =LLIM(I)
      IU   =IULIM(I)
      NEXT =IL
C
C     ----- OFF NUCLEI FUNCTIONS -----
C
      IF(NUCZ.EQ.0) GO TO 120
C
C     ----- 1S AND 2S ( OR 1S AND 1S' ) SHELLS -----
C
      IL0=IA(IL)+IL
      IL1=IA(IL+1)+IL+1
      X(IL0)=ENEG(NUCZ,1)
      X(IL1)=ENEG(NUCZ,2)
      NEXT=IL+2
      IF(NUCZ.LE.2) GO TO 120
C
C     ----- 2P SHELL -----
C
      IL2=IA(IL+2)+IL+2
      IL3=IA(IL+3)+IL+3
      IL4=IA(IL+4)+IL+4
      X(IL2)=ENEG(NUCZ,3)
      X(IL3)=ENEG(NUCZ,3)
      X(IL4)=ENEG(NUCZ,3)
      IF(NUCZ.GT.10) GO TO 110
C
C     ----- 2S' AND 2P' SHELL -----
C
      IL5=IA(IL+5)+IL+5
      IL6=IA(IL+6)+IL+6
      IL7=IA(IL+7)+IL+7
      IL8=IA(IL+8)+IL+8
      X(IL5)=ENEG(NUCZ,4)
      X(IL6)=ENEG(NUCZ,5)
      X(IL7)=ENEG(NUCZ,5)
      X(IL8)=ENEG(NUCZ,5)
      NEXT=IL+9
      GO TO 120
  110 CONTINUE
      IL5=IA(IL+5)+IL+5
      IL6=IA(IL+6)+IL+6
      IL7=IA(IL+7)+IL+7
      IL8=IA(IL+8)+IL+8
      X(IL5)=ENEG(NUCZ,4)
      X(IL6)=ENEG(NUCZ,5)
      X(IL7)=ENEG(NUCZ,5)
      X(IL8)=ENEG(NUCZ,5)
      IL9=IA(IL+9)+IL+9
      IL10=IA(IL+10)+IL+10
      IL11=IA(IL+11)+IL+11
      IL12=IA(IL+12)+IL+12
      X(IL9)=ENEG(NUCZ,6)
      X(IL10)=ENEG(NUCZ,7)
      X(IL11)=ENEG(NUCZ,7)
      X(IL12)=ENEG(NUCZ,7)
      NEXT=IL+13
C
  120 CONTINUE
      BITSY=-PT005
      TWEAK=BITSY * PT0001
      IF(NEXT.GT.IU) GO TO 140
      K=0
      DO 130 J=NEXT,IU
      K=K+1
      LOC=IA(J)+J
      X(LOC)=BITSY + DBLE( 10 * NUCZ + K ) * TWEAK
  130 CONTINUE
C
  140 CONTINUE
C
C     ----- CALCULATE OFF-DIAGONAL ELEMENTS OF THE -----
C           EXTENDED HUCKEL OPERATOR
C
      DO I=2,NUM
         DO J=1,I-1
            IJ=IA(I)+J
            II=IA(I)+I
            JJ=IA(J)+J
            X(IJ)=X(IJ)*(X(II)+X(JJ))*SCALE
         ENDDO
      ENDDO
C
C     ----- FOCK TRANSFORMATION -----
C
      CALL TFTR(X(I20),X(I10),X(I30),X(I41),IA,L0,L1,L1)
C
C     ----- DIAGONALIZE H MATRIX -----
C
      CALL DIASYM(X(I20),X(I30),X(I41),IA,L0,L0,L1)
C
C     ----- BACK-TRANSFORM THE EIGENVECTORS -----
C
      CALL DAREAD(IDAF,IODA,X(I10),L3,13)
      CALL TFSQB(X(I30),X(I10),X(I21),L0,L0,L1,L1)
C
      IF(ZERTOL.GT.ZERO) THEN
         NDUM=NUM*L0
         DO I=1,NDUM
            DUM=X(I-1+I30)/ZERTOL
            IF( ABS(DUM).GT.TOL) THEN
               WRITE(IW,7777) ZERTOL
               CALL HNDERR(3,ERRMSG)
            ENDIF
            IDUM=IDINT(DUM)
            X(I-1+I30)=DBLE(IDUM)*ZERTOL
         ENDDO
      ENDIF
C
      NDUM=NUM*L0
      DO I=1,NDUM
         DUM=X(I-1+I30)
         IF( ABS(DUM).LE.SMALL) DUM=ZERO
         X(I-1+I30)=DUM
      ENDDO
C
C     ----- WRITE MO'S AS -ALPHA- AND -BETA- SETS -----
C
      CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3,15)
      CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3,19)
C
C     ----- ASSIGN A SYMMETRY REPRESENTATION LABEL TO MO'S -----
C
      CALL DAREAD(IDAF,IODA,X(I50),L2,12)
      CALL DAREAD(IDAF,IODA,X(I10),L3,13)
      CALL SYMMOS(X(I50),X(I50),X(I50),X(I10),X(I50),X(I30),X(I21),
     1            IA,L0,L1,L0,L1)
      IF(     OUT.AND.NOC.GT.0)
     1 CALL PREVLS(X(I30),X(I41),X(I50),NOC,L1,L1)
      IF(.NOT.OUT.AND.NOC.GT.0)
     1 CALL GSSOUT(X(I30),X(I41),X(I50),NOC,L1,L1)
C
C     ----- RESET CORE MEMORY -----
C
      CALL CMEM(NGOTCM)
      IF(NGOTCM.NE.LOADCM) CALL SETC(NGOTCM)
      RETURN
 9999 FORMAT(/,' INITIAL GUESS ORBITALS GENERATED WITH -N31-',
     1         ' BASIS SET INITIAL GUESS ROUTINE',/)
 9998 FORMAT(  ' -GSSN31- NOT AVAILABLE FOR ATOMIC Z > 18 . STOP.')
 8889 FORMAT(/,1X,'OVERLAP MATRIX',/,1X,14(1H-))
 8888 FORMAT(/,1X,'CANONICAL ORTHONORMAL ORBITALS',/,1X,30(1H-))
 7777 FORMAT(  ' IN -GSSN31-, COEFFICIENT IS TOO LARGE TO BE',/,
     1 ' TRUNCATED WITH -ZERTOL- = ',E10.5,' INCREASE -ZERTOL-',/,
     2 ' OR SET IT TO EXACT ZERO.')
      END
      SUBROUTINE GSSDZV(NOC,ZERTOL)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (MXIODA=255)
      PARAMETER (MXATOM=128)
      PARAMETER (MXPRIM=2048)
      PARAMETER (MXSHEL=512)
      CHARACTER*8 ERRMSG
      REAL ATNUM
      LOGICAL OUT
      COMMON/IOFILE/IR,IW,IP
      COMMON/DAFILE/IDAF,NAV,IODA(MXIODA)
      COMMON/GSSPRT/PRTTOL,NPRINT
      COMMON/INFOA/NAT,ICH,MUL,NUM,NX,NE,NA,NB,ZAN(MXATOM),
     1                                         C(3,MXATOM)
      COMMON/NSHEL/
     1EX(MXPRIM),CS(MXPRIM),CP(MXPRIM),CD(MXPRIM),CF(MXPRIM),CG(MXPRIM),
     1KSTART(MXSHEL),KATOM(MXSHEL),KTYPE(MXSHEL),KNG(MXSHEL),
     2KLOC(MXSHEL),KMIN(MXSHEL),KMAX(MXSHEL),NSHELL
      COMMON/IJPAIR/IA(1)
      COMMON/SCM/X(1)
      DIMENSION IULIM(MXATOM),LLIM(MXATOM),ENEG(18,7)
      DIMENSION ERRMSG(3)
      DATA ERRMSG       /'PROGRAM ','STOP IN ','-GSSDZV-'/
      DATA PT005,PT0001 /0.005D+00,0.0001D+00/
      DATA PT5          /0.5D+00/
      DATA PT6          /0.6666666666D+00/
      DATA SCALE        /0.875D+00/
      DATA SMALL,ZERO   /1.0D-09,0.0D+00/
      DATA TOL          /2.0D+09/
C
      WRITE(IW,9999)
      OUT=NPRINT.NE.0
      L1= NUM
      L2=(NUM*(NUM+1))/2
      L3= NUM*NUM
C
C     ----- SET POINTERS FOR PARTITIONING OF CORE -----
C
      I10=     1
      I20=I10+L2
      I21=I10+L3
      I30=I20+L2
      I40=I30+L2
      I41=I30+L3
      I50=I40+L2
      I51=I50+L1
      I60=I50+L2
C
C     ----- GET CORE MEMORY -----
C
      CALL CMEM(LOADCM)
      LAST=I60-1
      LOC10=LOCCM(X(I10))
      NEED=LOC10+LAST
      IF(OUT) CALL NEEDCM(LAST,NEED)
      CALL SETC(NEED)
C
C     ----- NOT AVAILABLE FOR NUCZ > 18 -----
C
      DO I=1,NAT
         ATNUM=ZAN(I)
         NUCZ=IFIX(ATNUM)
         IF(NUCZ.GT.18) THEN
           WRITE(IW,9998)
           CALL HNDERR(3,ERRMSG)
         ENDIF
      ENDDO
C
C     ----- EXTENDED BASIS SET INITIAL GUESS ROUTINE -----
C           THIS PROGRAM WILL HANDLE EXTENDED BASIS SETS
C           IN WHICH THE ADDITIONAL FUNCTIONS ARE OF THE
C           TYPE (N+1)S, (N+1)P WHERE N IS THE PRINCIPAL
C           QUANTUM NUMBER.
C
C           ENEG(I,J) ARE THE DIAGONAL ELEMENTS OF THE HUCKEL
C           HAMILTONIAN IN ATOMIC UNITS.
C     I = ATOMIC NUMBER
C     J = 1   1S ORBITAL
C     J = 2   2S ORBITAL
C     J = 3   2P ORBITAL
C     J = 4   3S ORBITAL
C     J = 5   3P ORBITAL
C     J = 6   4S ORBITAL
C     J = 7   4P ORBITAL
C
      CALL HUCKEL(ENEG)
C
      DO I=1,2
         ENEG(I,1)=ENEG(I,1)*PT5
         ENEG(I,2)=ENEG(I,1)
      ENDDO
      DO I=3,10
         ENEG(I,2)=ENEG(I,2)*PT5
         ENEG(I,3)=ENEG(I,3)*PT5
         ENEG(I,4)=ENEG(I,2)
         ENEG(I,5)=ENEG(I,3)
      ENDDO
      DO I=11,18
         ENEG(I,4)=ENEG(I,4)*PT5
         ENEG(I,5)=ENEG(I,5)*PT5
         ENEG(I,6)=ENEG(I,4)
         ENEG(I,7)=ENEG(I,5)
      ENDDO
C
C     ----- SET IULIM AND LLIM -----
C
      DO I=1,NAT
          LLIM(I)=NUM+1
         IULIM(I)=0
         DO J=1,NSHELL
            IF(KATOM(J).EQ.I) THEN
                LLIM(I)=MIN( LLIM(I),KLOC(J)                )
               IULIM(I)=MAX(IULIM(I),KLOC(J)+KMAX(J)-KMIN(J))
            ENDIF
         ENDDO
      ENDDO
C
C     ----- GET CANONICAL ORTHONORMAL VECTORS -----
C
      CALL DAREAD(IDAF,IODA,X(I10),L2,12)
      IF(OUT) WRITE(IW,8889)
      IF(OUT) CALL PRTRL(X(I10),L1)
      CALL QMTCAN(X(I10),X(I20),X(I30),X(I41),X(I50),IA,L0,L1,L3,L1)
      IF(OUT) WRITE(IW,8888)
      IF(OUT) CALL PREVL(X(I30),X(I41),L0,L1,L1)
C
C     ----- READ IN THE OVERLAP MATRIX AND FORM HUCKEL MATRIX -----
C
      CALL DAREAD(IDAF,IODA,X(I10),L2,12)
      DO 140 I=1,NAT
      ATNUM=ZAN(I)
      NUCZ =IFIX(ATNUM)
      IL   =LLIM(I)
      IU   =IULIM(I)
      NEXT =IL
C
C     ----- OFF NUCLEI FUNCTIONS -----
C
      IF(NUCZ.EQ.0) GO TO 120
C
C     ----- 1S AND 2S ( OR 1S AND 1S' ) SHELLS -----
C
      IL0=IA(IL)+IL
      IL1=IA(IL+1)+IL+1
      X(IL0)=ENEG(NUCZ,1)
      X(IL1)=ENEG(NUCZ,2)
      NEXT=IL+2
      IF(NUCZ.LE.2) GO TO 120
C
C     ----- 2S' SHELL -----
C
      IL2=IA(IL+2)+IL+2
      X(IL2)=ENEG(NUCZ,4)
      IF(NUCZ.GT.10) GO TO 110
C
C     ----- 2P SHELL -----
C
      IL3=IA(IL+3)+IL+3
      IL4=IA(IL+4)+IL+4
      IL5=IA(IL+5)+IL+5
      X(IL3)=ENEG(NUCZ,3)
      X(IL4)=ENEG(NUCZ,3)
      X(IL5)=ENEG(NUCZ,3)
C
C     ----- 2P' SHELL -----
C
      IL6=IA(IL+6)+IL+6
      IL7=IA(IL+7)+IL+7
      IL8=IA(IL+8)+IL+8
      X(IL6)=ENEG(NUCZ,5)
      X(IL7)=ENEG(NUCZ,5)
      X(IL8)=ENEG(NUCZ,5)
      NEXT=IL+9
      GO TO 120
  110 CONTINUE
      IL3=IA(IL+3)+IL+3
      X(IL3)=ENEG(NUCZ,6)
      IL4=IA(IL+4)+IL+4
      IL5=IA(IL+5)+IL+5
      IL6=IA(IL+6)+IL+6
      X(IL4)=ENEG(NUCZ,3)
      X(IL5)=ENEG(NUCZ,3)
      X(IL6)=ENEG(NUCZ,3)
      IL7=IA(IL+7)+IL+7
      IL8=IA(IL+8)+IL+8
      IL9=IA(IL+9)+IL+9
      X(IL7)=ENEG(NUCZ,5)
      X(IL8)=ENEG(NUCZ,5)
      X(IL9)=ENEG(NUCZ,5)
      IL10=IA(IL+10)+IL+10
      IL11=IA(IL+11)+IL+11
      IL12=IA(IL+12)+IL+12
      X(IL10)=ENEG(NUCZ,7)
      X(IL11)=ENEG(NUCZ,7)
      X(IL12)=ENEG(NUCZ,7)
      NEXT=IL+13
C
  120 CONTINUE
      BITSY=-PT005
      TWEAK=BITSY * PT0001
      IF(NEXT.GT.IU) GO TO 140
      K=0
      DO 130 J=NEXT,IU
      K=K+1
      LOC=IA(J)+J
      X(LOC)=BITSY + DBLE( 10 * NUCZ + K ) * TWEAK
  130 CONTINUE
C
  140 CONTINUE
C
C     ----- CALCULATE OFF-DIAGONAL ELEMENTS OF THE -----
C           EXTENDED HUCKEL OPERATOR
C
      DO I=2,NUM
         DO J=1,I-1
            IJ=IA(I)+J
            II=IA(I)+I
            JJ=IA(J)+J
            X(IJ)=X(IJ)*(X(II)+X(JJ))*SCALE
         ENDDO
      ENDDO
C
C     ----- FOCK TRANSFORMATION -----
C
      CALL TFTR(X(I20),X(I10),X(I30),X(I41),IA,L0,L1,L1)
C
C     ----- DIAGONALIZE H MATRIX -----
C
      CALL DIASYM(X(I20),X(I30),X(I41),IA,L0,L0,L1)
C
C     ----- BACK-TRANSFORM THE EIGENVECTORS -----
C
      CALL DAREAD(IDAF,IODA,X(I10),L3,13)
      CALL TFSQB(X(I30),X(I10),X(I21),L0,L0,L1,L1)
C
      IF(ZERTOL.GT.ZERO) THEN
         NDUM=NUM*L0
         DO I=1,NDUM
            DUM=X(I-1+I30)/ZERTOL
            IF( ABS(DUM).GT.TOL) THEN
               WRITE(IW,7777) ZERTOL
               CALL HNDERR(3,ERRMSG)
            ENDIF
            IDUM=IDINT(DUM)
            X(I-1+I30)=DBLE(IDUM)*ZERTOL
         ENDDO
      ENDIF
C
      NDUM=NUM*L0
      DO I=1,NDUM
         DUM=X(I-1+I30)
         IF( ABS(DUM).LE.SMALL) DUM=ZERO
         X(I-1+I30)=DUM
      ENDDO
C
C     ----- WRITE MO'S AS -ALPHA- AND -BETA- SETS -----
C
      CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3,15)
      CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3,19)
C
C     ----- ASSIGN A SYMMETRY REPRESENTATION LABEL TO MO'S -----
C
      CALL DAREAD(IDAF,IODA,X(I50),L2,12)
      CALL DAREAD(IDAF,IODA,X(I10),L3,13)
      CALL SYMMOS(X(I50),X(I50),X(I50),X(I10),X(I50),X(I30),X(I21),
     1            IA,L0,L1,L0,L1)
      IF(     OUT.AND.NOC.GT.0)
     1 CALL PREVLS(X(I30),X(I41),X(I50),NOC,L1,L1)
      IF(.NOT.OUT.AND.NOC.GT.0)
     1 CALL GSSOUT(X(I30),X(I41),X(I50),NOC,L1,L1)
C
C     ----- RESET CORE MEMORY -----
C
      CALL CMEM(NGOTCM)
      IF(NGOTCM.NE.LOADCM) CALL SETC(NGOTCM)
      RETURN
 9999 FORMAT(/,' INITIAL GUESS ORBITALS GENERATED WITH -DZV-',
     1         ' BASIS SET INITIAL GUESS ROUTINE',/)
 9998 FORMAT(  ' -GSSDZV- NOT AVAILABLE FOR ATOMIC Z > 18 . STOP.')
 8889 FORMAT(/,1X,'OVERLAP MATRIX',/,1X,14(1H-))
 8888 FORMAT(/,1X,'CANONICAL ORTHONORMAL ORBITALS',/,1X,30(1H-))
 7777 FORMAT(  ' IN -GSSDZV-, COEFFICIENT IS TOO LARGE TO BE',/,
     1 ' TRUNCATED WITH -ZERTOL- = ',E10.5,' INCREASE -ZERTOL-',/,
     2 ' OR SET IT TO EXACT ZERO.')
      END
      SUBROUTINE GSSINP(NOC,ZERTOL,NFORMT,BETA,BSTATE,BWRIT,
     1                  MORDER,JORDER,GSSFIL)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (MXIODA=255)
      PARAMETER (MXATOM=128)
      CHARACTER*8 ERRMSG
      LOGICAL      OUT
      LOGICAL      READY
      LOGICAL      AOFA,BOFA,AOFB,BOFB
      LOGICAL      BWRIT
      INTEGER      BETA
      INTEGER      BSTATE
      LOGICAL      NEWFIL
      CHARACTER*80 GSSFIL
C#g77 ------------------------------------------
C#g77 The following character strings are now
C#g77 explitly defined:
      CHARACTER*8 VEC,VECA,VECB,VECAA,VECBA,
     1            VECAB,VECBB,EIG,EIGA,EIGB,
     2            EIGAA,EIGBA,EIGAB,EIGBB,
     3            WORD,WRD
C#g77 ------------------------------------------
      COMMON/IOFILE/IR,IW,IP
      COMMON/DAFILE/IDAF,NAV,IODA(MXIODA)
      COMMON/GSSPRT/PRTTOL,NPRINT
      COMMON/INFOA/NAT,ICH,MUL,NUM,NX,NE,NA,NB,ZAN(MXATOM),
     1                                         C(3,MXATOM)
      COMMON/IJPAIR/IA(1)
      COMMON/SCM/X(1)
      DIMENSION ERRMSG(3)
      DIMENSION JORDER(*)
      DATA ERRMSG      /'PROGRAM ','STOP IN ','-GSSINP-'/
      DATA VEC         /' $VEC   '/
      DATA VECA ,VECB  /' $VECA  ',' $VECB  '/
      DATA VECAA,VECBA /' $VECA-A',' $VECB-A'/
      DATA VECAB,VECBB /' $VECA-B',' $VECB-B'/
      DATA EIG         /' $EIG   '/
      DATA EIGA ,EIGB  /' $EIGA  ',' $EIGB  '/
      DATA EIGAA,EIGBA /' $EIGA-A',' $EIGB-A'/
      DATA EIGAB,EIGBB /' $EIGA-B',' $EIGB-B'/
      DATA SMALL,ZERO  /1.0D-09,0.0D+00/
      DATA TOL         /2.0D+09/
C
      OUT=NPRINT.NE.0
C
      WRITE(IW,9999)
      WRITE(IW,9994)
      IF(NFORMT.EQ.0) NCOEF= 5
      IF(NFORMT.NE.0) NCOEF=15
      L1= NUM
      L2=(NUM*(NUM+1))/2
      L3= NUM* NUM
C
C     ----- SET POINTERS FOR PARTITIONING OF CORE -----
C
      I10=     1
      I20=I10+L2
      I21=I10+L3
      I30=I20+L2
      I40=I30+L2
      I41=I30+L3
      I50=I40+L2
      I51=I50+L1
      I60=I50+L2
C
C     ----- GET CORE MEMORY -----
C
      CALL CMEM(LOADCM)
      LAST=I60-1
      LOC10=LOCCM(X(I10))
      NEED=LOC10+LAST
      IF(OUT) CALL NEEDCM(LAST,NEED)
      CALL SETC(NEED)
C
C     ----- GET CANONICAL ORBITALS -----
C
      CALL DAREAD(IDAF,IODA,X(I10),L2,12)
      IF(OUT) WRITE(IW,8889)
      IF(OUT) CALL PRTRL(X(I10),L1)
      CALL QMTCAN(X(I10),X(I20),X(I30),X(I41),X(I50),IA,L0,L1,L3,L1)
      IF(OUT) WRITE(IW,8888)
      IF(OUT) CALL PREVL(X(I30),X(I41),L0,L1,L1)
C
      IF(NOC.LE.0) THEN
         WRITE(IW,9993)
         CALL HNDERR(3,ERRMSG)
      ENDIF
C
C     ----- CHECK WHICH FILE HAS THE INPUT VECTORS -----
C
      NEWFIL=.FALSE.
      DO I=1,80
         NEWFIL=NEWFIL.OR.(GSSFIL(I:I).NE.' ')
      ENDDO
      IF(NEWFIL) THEN
         IRSAV=IR
         IR   =5
         CALL GSSCLS(IR)
         CALL GSSOPN(IR,GSSFIL)
         WRITE(IW,7776) GSSFIL
      ENDIF
C
C     ----- IMPLIED LOOP OVER CASES -----
C
      AOFA=.TRUE.
      BOFA=.FALSE.
      AOFB=.FALSE.
      BOFB=.FALSE.
      ICAS=1
  100 CONTINUE
C
      REWIND IR
  110 READ(IR,9998,END=120,ERR=120) WORD
      GO TO 130
  120 WRITE(IW,9997) AOFA,BOFA,AOFB,BOFB
      CALL HNDERR(3,ERRMSG)
  130 CONTINUE
      READY=(AOFA.AND.(WORD.EQ.VECAA.OR.WORD.EQ.VECA
     1                              .OR.WORD.EQ.VEC  ))
      READY=(BOFA.AND.(WORD.EQ.VECBA.OR.WORD.EQ.VECB )).OR.READY
      READY=(AOFB.AND.(WORD.EQ.VECAB                 )).OR.READY
      READY=(BOFB.AND.(WORD.EQ.VECBB                 )).OR.READY
      IF(.NOT.READY) GO TO 110
C
C     ----- READ VECTORS -----
C
      DO 400 J=1,NOC
         IMAX=0
         IC=0
  200    IMIN=IMAX+1
            IMAX=IMAX+NCOEF
            IC=IC+1
            IF(IMAX.GT.NUM) IMAX=NUM
               IF(NFORMT.EQ.0.AND.NUM.LE.99)
     1         READ(IR,9996) JJ,(X(I30-1+(J-1)*L1+I),I=IMIN,IMAX)
               IF(NFORMT.NE.0.AND.NUM.LE.99)
     1         READ(IR,9992) JJ,(X(I30-1+(J-1)*L1+I),I=IMIN,IMAX)
               IF(NFORMT.EQ.0.AND.NUM.GT.99)
     1         READ(IR,9988) JJ,(X(I30-1+(J-1)*L1+I),I=IMIN,IMAX)
               IF(NFORMT.NE.0.AND.NUM.GT.99)
     1         READ(IR,9987) JJ,(X(I30-1+(J-1)*L1+I),I=IMIN,IMAX)
            IF(JJ.EQ.J) GO TO 300
               WRITE(IW,9995) J,IC
               CALL HNDERR(3,ERRMSG)
  300    IF(IMAX.LT.NUM) GO TO 200
  400    CONTINUE
C
C     ----- SORT THE BASIS SETS IF ATOMS ORDER HAS BEEN CHANGED -----
C
      IF(MORDER.NE.0) CALL GSSMOV(X(I30),NUM,X(I41),X(I10),
     1                            X(I10+NAT),JORDER,NOC)
C
      DO 410 I=1,L1
  410    X(I-1+I41)=ZERO
C
      IF(OUT) WRITE(IW,9991)
      IF(OUT.AND.NOC.GT.0) CALL  PREVL(X(I30),X(I41),NOC,L1,L1)
C
C     ----- TRUNCATE VECTOR COEFFICIENTS -----
C
      IF(ZERTOL.EQ.ZERO) GO TO 440
         NDUM=NUM*NOC
         DO 430 I=1,NDUM
            DUM=X(I-1+I30)/ZERTOL
            IF( ABS(DUM).LE.TOL) GO TO 420
               WRITE(IW,7777) ZERTOL
               CALL HNDERR(3,ERRMSG)
  420       CONTINUE
            IDUM=IDINT(DUM)
            X(I-1+I30)=DBLE(IDUM)*ZERTOL
  430       CONTINUE
  440 CONTINUE
C
      NDUM=NUM*NOC
      DO 450 I=1,NDUM
         DUM=X(I-1+I30)
         IF( ABS(DUM).LE.SMALL) DUM=ZERO
         X(I-1+I30)=DUM
  450    CONTINUE
C
C     ----- ORTHONORMALIZE THE ORBITALS -----
C           NOTE = IF -NOC- GT -L0- THEN
C           RE-ADJUST THE NUMBER OF MO'S
C
      NOC=MIN(NOC,L0)
      CALL ORTHO(X(I10),X(I10),X(I30),X(I41),IA,
     1           NOC,L0,L1,L2,L3,L1)
C
C     ----- WRITE MO'S ON -DAF- -----
C
      DO 460 I=1,L1
  460    X(I-1+I41)=ZERO
C
      GO TO (510,520,530,540),ICAS
  510    CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3, 15)
         CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3, 19)
         IF(BWRIT) THEN
            CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3,125)
            CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3,129)
            CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3,135)
            CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3,139)
         ENDIF
         GO TO 550
  520    CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3, 19)
         IF(BWRIT) THEN
            CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3,129)
            CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3,139)
         ENDIF
         GO TO 550
  530    CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3, 15)
         CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3, 19)
         CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3,135)
         CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3,139)
         GO TO 550
  540    CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3, 19)
         CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3,139)
C
  550 CONTINUE
C
C     ----- ASSIGN A SYMMETRY REPRESENTATION LABEL TO MO'S -----
C
      CALL DAREAD(IDAF,IODA,X(I50),L2,12)
      CALL DAREAD(IDAF,IODA,X(I10),L3,13)
      CALL SYMMOS(X(I50),X(I50),X(I50),X(I10),X(I50),X(I30),X(I21),
     1            IA,L0,L1,L0,L1)
      WRITE(IW,9989) WORD
      IF(OUT) WRITE(IW,9990)
      IF(     OUT.AND.NOC.GT.0)
     1 CALL PREVLS(X(I30),X(I41),X(I50),NOC,L1,L1)
      IF(.NOT.OUT.AND.NOC.GT.0)
     1 CALL GSSOUT(X(I30),X(I41),X(I50),NOC,L1,L1)
C
C     ----- LOOP BACK -----
C
      IF(BETA.NE.0.AND.AOFA) THEN
      ICAS=2
      AOFA=.FALSE.
      BOFA=.TRUE.
      GO TO 100
      ELSE IF(BSTATE.NE.0.AND.(.NOT.AOFB.AND..NOT.BOFB)) THEN
      ICAS=3
      AOFA=.FALSE.
      BOFA=.FALSE.
      AOFB=.TRUE.
      BOFB=.FALSE.
      GO TO 100
      ELSE IF(BSTATE.NE.0.AND.BETA.NE.0.AND.AOFB) THEN
      ICAS=4
      AOFB=.FALSE.
      BOFB=.TRUE.
      GO TO 100
      ENDIF
C
C     ----- RESET FILES IF NEEDED -----
C
      IF(NEWFIL) THEN
         CALL GSSCLS(IR)
         IR=IRSAV
      ENDIF
C
C     ----- RESET CORE MEMORY -----
C
      CALL CMEM(NGOTCM)
      IF(NGOTCM.NE.LOADCM) CALL SETC(LOADCM)
      RETURN
 9999 FORMAT(/,' INITIAL GUESS ORBITALS READ FROM CARDS')
 9998 FORMAT(A8)
 9997 FORMAT(  ' ONE OF THE VECTOR SETS NEEDED FOR THIS RUN',
     1         ' COULD NOT BE FOUND. STOP. ',/,
     2         ' AOFA, BOFA, AOFB, BOFB = ',4L4)
 9996 FORMAT(I2,3X,5E15.8)
 9995 FORMAT(  ' IN READING THE MO COEFFICIENTS FROM CARDS',/,
     1 ' THE OCCUPIED ORBITALS ARE OUT OF ORDER ',2I5)
 9994 FORMAT(/,' WARNING = ONLY THE -MO- SEQUENCE ORDER IS CHECKED.',
     1         ' THE CARD SEQUENCE FOR A GIVEN -MO- IS NOT CHECKED.')
 9993 FORMAT(  ' IN -GSSINP- , NOC = 0 . STOP. ')
 9992 FORMAT(I2,3X,15F5.2)
 9991 FORMAT(/,' VECTORS READ FROM CARDS ')
 9990 FORMAT(/,' ORTHONORMALIZED VECTORS ')
 9989 FORMAT(/,' VECTOR SET LABEL = ',A8,/,1X,16(1H-),3X,8(1H-))
 9988 FORMAT(I3,2X,5E15.8)
 9987 FORMAT(I3,2X,15F5.2)
 8889 FORMAT(/,1X,'OVERLAP MATRIX',/,1X,14(1H-))
 8888 FORMAT(/,1X,'CANONICAL ORTHONORMAL ORBITALS',/,1X,30(1H-))
 7777 FORMAT(' IN -GSSINP-, COEFFICIENT IS TOO LARGE TO BE',/,
     1 ' TRUNCATED WITH -ZERTOL- = ',E10.5,' INCREASE -ZERTOL-',/,
     2 ' OR SET IT TO EXACT ZERO.')
 7776 FORMAT(' INITIAL ORBITALS ARE BEING READ FROM ALTERNATE FILE',/,
     1       ' -GSSFIL- = ---',A80,'---')
      END
      SUBROUTINE GSSCLS(NFT)
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER*8 ERRMSG
C#g77 COMMON/IOFILE/IR,IW
      COMMON/IOFILE/IR,IW,IP
      DIMENSION ERRMSG(3)
      DATA ERRMSG  /'PROGRAM ','STOP IN ','-GSSCLS-'/
      CLOSE(UNIT=NFT,STATUS='KEEP',ERR=10)
      RETURN
   10 WRITE(IW,9999) NFT
      CALL HNDERR(3,ERRMSG)
      RETURN
 9999 FORMAT(/,' ----- ERROR CLOSING UNIT ',I3,' IN -GSSCLS- . STOP .')
      END
      SUBROUTINE GSSOPN(NFT,GSSFIL)
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER*80 GSSFIL
      CHARACTER*8 ERRMSG
C#g77 COMMON/IOFILE/IR,IW
      COMMON/IOFILE/IR,IW,IP
      DIMENSION ERRMSG(3)
      DATA ERRMSG  /'PROGRAM ','STOP IN ','-GSSOPN-'/
      OPEN(UNIT=NFT,FILE=GSSFIL,STATUS='OLD',
     1     ACCESS='SEQUENTIAL',FORM=  'FORMATTED',ERR=10)
      RETURN
   10 WRITE(IW,9999) GSSFIL,NFT
      CALL HNDERR(3,ERRMSG)
      RETURN
 9999 FORMAT(/,' ----- ERROR OPENING FILE -',A80,'-',/,
     1         '       AS UNIT ',I3,' IN -GSSOPN- . STOP.')
      RETURN
      END
      SUBROUTINE GSSMOV(V,NDIM,T,JSTART,JEND,JORDER,NORB)
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (MXATOM=128)
      PARAMETER (MXPRIM=2048)
      PARAMETER (MXSHEL=512)
C#g77 COMMON/IOFILE/IR,IW
      COMMON/IOFILE/IR,IW,IP
      COMMON/INFOA/NAT,ICH,MUL,NUM,NX,NE,NA,NB,ZAN(MXATOM),
     1                                         C(3,MXATOM)
      COMMON/NSHEL/
     1EX(MXPRIM),CS(MXPRIM),CP(MXPRIM),CD(MXPRIM),CF(MXPRIM),CG(MXPRIM),
     1KSTART(MXSHEL),KATOM(MXSHEL),KTYPE(MXSHEL),KNG(MXSHEL),
     2KLOC(MXSHEL),KMIN(MXSHEL),KMAX(MXSHEL),NSHELL
      DIMENSION V(NDIM,*),T(*),JSTART(*),JEND(*),JORDER(*)
C
C     ----- FIRST GET THE MAPPING OF BASIS FUNCTIONS -----
C
      K = 1
      IATM = 1
      DO 10 I=1,NSHELL
      IF(KATOM(I).NE.IATM) THEN
         JSTART(IATM) = K
         K            = KLOC(I)
         JEND(IATM)   = K-1
         IATM         = IATM+1
      ENDIF
   10 CONTINUE
      JSTART(IATM) = K
      JEND(IATM) = NUM
C
C     ----- NOW SORT THE BASIS SET -----
C
      DO 40 I=1,NORB
         K = 0
         DO 20 IATM=1,NAT
            ISTART = JSTART(JORDER(IATM))
            IEND   = JEND(JORDER(IATM))
            DO 20 J=ISTART,IEND
               K = K+1
   20          T(J) = V(K,I)
         DO 30 J=1,NUM
   30       V(J,I) = T(J)
   40    CONTINUE
C
      WRITE(IW,9999) (JORDER(IAT),IAT=1,NAT)
      RETURN
 9999 FORMAT(' OLD SERIAL NUMBER OF THE ATOMS = ',/,(32I4))
      END
      SUBROUTINE GSSCAT(NOC,ZERTOL,NFORMT,NFRAG,LFRAG)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (MXIODA=255)
      PARAMETER (MXATOM=128)
      CHARACTER*8 ERRMSG
      INTEGER CSVRUN
      INTEGER CSVSTP
      LOGICAL DBUG
      LOGICAL OUT
      LOGICAL READY
C#g77 ------------------------------------------
C#g77 The following character strings are now
C#g77 explitly defined:
      CHARACTER*8 ENDWRD,VEC,VECA,VECB,VECAA,VECBA,
     1            VECAB,VECBB,WRD
C#g77 ------------------------------------------
      COMMON/IOFILE/IR,IW,IP
      COMMON/DAFILE/IDAF,NAV,IODA(MXIODA)
      COMMON/GSSPRT/PRTTOL,NPRINT
      COMMON/CSVOPT/CSVRUN,CSVSTP,CSVE(7),
     1              NOCO1,NOCO2,NOVI1,NOVI2,NOPS2
      COMMON/INFOA/NAT,ICH,MUL,NUM,NX,NE,NA,NB,ZAN(MXATOM),
     1                                         C(3,MXATOM)
      COMMON/IJPAIR/IA(1)
      COMMON/SCM/X(1)
      DIMENSION LFRAG(2,1)
      DIMENSION ERRMSG(3)
      DATA ERRMSG       /'PROGRAM ','STOP IN ','-GSSCAT-'/
      DATA ENDWRD       /' $END   '/
      DATA VEC          /' $VEC   '/
      DATA VECA ,VECB   /' $VECA  ',' $VECB  '/
      DATA VECAA,VECBA  /' $VECA-A',' $VECB-A'/
      DATA VECAB,VECBB  /' $VECA-B',' $VECB-B'/
      DATA SMALL,ZERO   /1.0D-09,0.0D+00/
      DATA TOL          /2.0D+09/
C
      DBUG=.TRUE.
      OUT=NPRINT.NE.0
C
      IF(NFORMT.EQ.0) THEN
         NCOEF=5
      ELSE
         NCOEF=15
      ENDIF
C
      WRITE(IW,9999)
C
      L1= NUM
      L2=(NUM*(NUM+1))/2
      L3= NUM*NUM
C
      IF(NOC.LE.0) THEN
         WRITE(IW,9998)
         CALL HNDERR(3,ERRMSG)
         RETURN
      ENDIF
C
      IF(NFRAG.LE.0) THEN
         WRITE(IW,9997)
         CALL HNDERR(3,ERRMSG)
      ENDIF
C
      NDUM=0
      MDUM=0
      DO 10 IFRAG=1,NFRAG
         NDUM=NDUM+LFRAG(1,IFRAG)
   10    MDUM=MDUM+LFRAG(2,IFRAG)
      IF(NDUM.NE.NUM.OR.MDUM.NE.NOC) THEN
         WRITE(IW,9996) NDUM,NUM,MDUM,NOC
         CALL HNDERR(3,ERRMSG)
      ENDIF
C
C     ----- SET POINTERS FOR PARTITIONING OF CORE -----
C
      I10=     1
      I20=I10+L2
      I21=I10+L3
      I30=I20+L2
      I40=I30+L2
      I41=I30+L3
      I50=I40+L2
      I51=I50+L1
      I60=I50+L2
C
C     ----- GET CORE MEMORY -----
C
      CALL CMEM(LOADCM)
      LAST=I60-1
      LOC10=LOCCM(X(I10))
      NEED=LOC10+LAST
      IF(OUT) CALL NEEDCM(LAST,NEED)
      CALL SETC(NEED)
C
C     ----- GET CANONICAL ORBITALS -----
C
      CALL DAREAD(IDAF,IODA,X(I10),L2,12)
      IF(OUT) WRITE(IW,8888)
      IF(OUT) CALL PRTRL(X(I10),L1)
      CALL QMTCAN(X(I10),X(I20),X(I30),X(I41),X(I50),IA,L0,L1,L3,L1)
      IF(OUT) WRITE(IW,8887)
      IF(OUT) CALL PREVL(X(I30),X(I41),L0,L1,L1)
C
C     ----- LOCATE AND READ FRAGMENT ORBITALS -----
C
      IFRAG=0
      ICOEF=I30
      DO 100 I=1,NUM*NUM
  100    X(I-1+ICOEF)=ZERO
C
      REWIND IR
  110 READ(IR,9995,END=120,ERR=120) WRD
      GO TO 130
  120 WRITE(IW,9994)
      CALL HNDERR(3,ERRMSG)
  130 READY=WRD.EQ.VEC.OR.WRD.EQ.VECA .OR.WRD.EQ.VECB .OR.
     1                    WRD.EQ.VECAA.OR.WRD.EQ.VECAB.OR.
     2                    WRD.EQ.VECBA.OR.WRD.EQ.VECBB
      IF(.NOT.READY) GO TO 110
C
      IFRAG=IFRAG+1
      INUM =LFRAG(1,IFRAG)
      INOC =LFRAG(2,IFRAG)
      IF(OUT) WRITE(IW,9988) IFRAG,INUM,INOC,ICOEF
C
      DO 220 J=1,INOC
         IMAX=0
         ICAR=0
  210    IMIN=IMAX+1
         IMAX=IMAX+NCOEF
         ICAR=ICAR+1
         IF(IMAX.GT.INUM) IMAX=INUM
         IF(INUM.LE.99)THEN
            IF(NFORMT.EQ.0) THEN
               READ(IR,9993) JDUM,(X(I-1+ICOEF),I=IMIN,IMAX)
            ELSE
               READ(IR,9987) JDUM,(X(I-1+ICOEF),I=IMIN,IMAX)
            ENDIF
         ELSE
            IF(NFORMT.EQ.0) THEN
               READ(IR,9992) JDUM,(X(I-1+ICOEF),I=IMIN,IMAX)
            ELSE
               READ(IR,9986) JDUM,(X(I-1+ICOEF),I=IMIN,IMAX)
            ENDIF
         ENDIF
         IF(JDUM.NE.J) THEN
            WRITE(IW,9991) J,JDUM
            CALL HNDERR(3,ERRMSG)
         ENDIF
         IF(IMAX.LT.INUM) GO TO 210
         ICOEF=ICOEF+NUM
  220 CONTINUE
C
  310 READ(IR,9995,END=320,ERR=320) WRD
      GO TO 330
  320 WRITE(IW,9994)
      CALL HNDERR(3,ERRMSG)
  330 IF(WRD.NE.ENDWRD) GO TO 310
C
      ICOEF=ICOEF+INUM
      IF(IFRAG.LT.NFRAG) GO TO 110
C
C     ----- MASSAGE THE NOW-CONCATENATED ORBITAL SET -----
C
      DO 410 I=1,L1
  410 X(I-1+I41)=ZERO
      IF(OUT) WRITE(IW,9990)
      IF(OUT.AND.NOC.GT.0) CALL  PREVL(X(I30),X(I41),NOC,L1,L1)
C
C     ----- TRUNCATE VECTOR COEFFICIENTS -----
C
      IF(ZERTOL.EQ.ZERO) GO TO 440
      NDUM=NUM*NOC
      DO 430 I=1,NDUM
      DUM=X(I-1+I30)/ZERTOL
      IF( ABS(DUM).LE.TOL) GO TO 420
      WRITE(IW,7777) ZERTOL
      CALL HNDERR(3,ERRMSG)
  420 CONTINUE
      IDUM=IDINT(DUM)
      X(I-1+I30)=DBLE(IDUM)*ZERTOL
  430 CONTINUE
  440 CONTINUE
C
      NDUM=NUM*NOC
      DO 450 I=1,NDUM
      DUM=X(I-1+I30)
      IF( ABS(DUM).LE.SMALL) DUM=ZERO
      X(I-1+I30)=DUM
  450 CONTINUE
C
      IF(CSVRUN.EQ.1) THEN
C
C     -----     REORDER MO'S FOR -CSOV- ANALYSIS       -----
C     ----- ORDER IS: -OCCA-, -OCCB-, -VIRTB-, -VIRTA- -----
C
         IF(DBUG) THEN
            WRITE(IW,*) '-CSOV- DATA, NOCO1,NOVI1,NOCO2,NOVI2 = ',
     1                                NOCO1,NOVI1,NOCO2,NOVI2
         ENDIF
         CALL DCOPY(L1*       NOVI1 ,X(I30+L1* NOCO1             ),1,
     1                               X(I10                       ),1)
         CALL DCOPY(L1*(NOCO2+NOVI2),X(I30+L1*(NOCO1+NOVI1)      ),1,
     1                               X(I30+L1* NOCO1             ),1)
         CALL DCOPY(L1*       NOVI1 ,X(I10                       ),1,
     1                               X(I30+L1*(NOCO1+NOCO2+NOVI2)),1)
         NOCO2 = NOCO2-NOPS2
C
         CALL DAWRIT(IDAF,IODA,X(I30),L3,39,NAV)
C
         WRITE(IW,9985)
      ENDIF
C
C
C     ----- ORTHONORMALIZE THE ORBITALS -----
C
      CALL ORTHO(X(I10),X(I10),X(I30),X(I41),IA,
     1            NOC,L0,L1,L2,L3,L1)
C
      IF(CSVRUN.EQ.1) THEN
         CALL DAWRIT(IDAF,IODA,X(I30),L3,40,NAV)
      ENDIF
C
C     ----- WRITE MO'S ON -DAF- -----
C
      DO 460 I=1,L1
  460 X(I-1+I41)=ZERO
C
      CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3, 15)
      CALL GSSWT(X(I30),X(I10),X(I41),L1,L2,L3, 19)
C
C     ----- ASSIGN A SYMMETRY REPRESENTATION LABEL TO MO'S -----
C
      CALL DAREAD(IDAF,IODA,X(I50),L2,12)
      CALL DAREAD(IDAF,IODA,X(I10),L3,13)
      CALL SYMMOS(X(I50),X(I50),X(I50),X(I10),X(I50),X(I30),X(I21),
     1            IA,L0,L1,L0,L1)
      IF(OUT) WRITE(IW,9989)
      IF(     OUT.AND.NOC.GT.0)
     1 CALL PREVLS(X(I30),X(I41),X(I50),NOC,L1,L1)
      IF(.NOT.OUT.AND.NOC.GT.0)
     1 CALL GSSOUT(X(I30),X(I41),X(I50),NOC,L1,L1)
C
      RETURN
 9999 FORMAT(/,' INITIAL GUESS ORBITALS GENERATED BY CONCATENATING',
     1         ' FRAGMENT MOLECULAR ORBITALS',/)
 9998 FORMAT(  ' IN -GSSCAT- ,   NOC = 0 . STOP. ')
 9997 FORMAT(  ' IN -GSSCAT- , NFRAG = 0 . STOP. ')
 9996 FORMAT(' IN -GSSCAT- , THE PIECES OF INFORMATION ABOUT THE',
     1       ' FRAGMENTS DO NOT ADD UP TO -NUM- AND -NOC- . STOP.',/,
     2       ' NDUM = ',I6,' NUM = ',I6,' MDUM = ',I6,' NOC = ',I6)
 9995 FORMAT(A8)
 9994 FORMAT(' IN -GSSCAT- , UNABLE TO LOCAL FRAGMENT ORBITALS',
     1       ' AT -$VEC- . STOP .')
 9993 FORMAT(I2,3X,5E15.8)
 9992 FORMAT(I3,2X,5E15.8)
 9991 FORMAT(' IN READING THE MOS FROM CARDS IN -GSSCAT- , THE MOS',
     1       ' ARE OUT-OF-ORDER ',2I5,' STOP . ')
 9990 FORMAT(/,' CONCATENATED ORBITAL SET ')
 9989 FORMAT(/,' ORTHONORMALIZED VECTORS ')
 9988 FORMAT(' FRAGMENT ORBITAL SET # = ',I4,
     1       ' INUM, INOC, ICOEF = ',2I5,I15)
 9987 FORMAT(I2,3X,15F5.2)
 9986 FORMAT(I3,2X,15F5.2)
 9985 FORMAT(  ' ORBITALS RE-ORDERED FOR -CSOV- ANALYSIS .')
 8888 FORMAT(/,1X,'OVERLAP MATRIX',/,1X,14(1H-))
 8887 FORMAT(/,1X,'CANONICAL ORTHONORMAL ORBITALS',/,1X,30(1H-))
 7777 FORMAT(' IN -GSSCAT-, COEFFICIENT IS TOO LARGE TO BE',/,
     1 ' TRUNCATED WITH -ZERTOL- = ',E10.5,' INCREASE -ZERTOL-',/,
     2 ' OR SET IT TO EXACT ZERO.')
      END
      SUBROUTINE GSSDAF(NOC)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (MXIODA=255)
      PARAMETER (MXATOM=128)
      LOGICAL OUT
      COMMON/IJPAIR/IA(1)
      COMMON/INFOA/NAT,ICH,MUL,NUM,NX,NE,NA,NB,ZAN(MXATOM),
     1                                         C(3,MXATOM)
      COMMON/IOFILE/IR,IW,IP
      COMMON/DAFILE/IDAF,NAV,IODA(MXIODA)
      COMMON/GSSPRT/PRTTOL,NPRINT
      COMMON/SCM/X(1)
C
      WRITE(IW,9999)
      OUT=NPRINT.NE.0
      L1= NUM
      L2=(NUM*(NUM+1))/2
      L3= NUM*NUM
C
C     ----- SET POINTERS FOR PARTITIONING OF CORE -----
C
      I10=     1
      I20=I10+L2
      I21=I10+L3
      I30=I20+L2
      I40=I30+L2
      I41=I30+L3
      I50=I40+L2
      I51=I50+L1
      I60=I50+L2
C
C     ----- GET CORE MEMORY -----
C
      CALL CMEM(LOADCM)
      LAST=I60-1
      LOC10=LOCCM(X(I10))
      NEED=LOC10+LAST
      IF(OUT) CALL NEEDCM(LAST,NEED)
      CALL SETC(NEED)
C
C     ----- GET CANONICAL ORBITALS -----
C
      CALL DAREAD(IDAF,IODA,X(I10),L2,12)
      IF(OUT) WRITE(IW,8889)
      IF(OUT) CALL PRTRL(X(I10),L1)
      CALL QMTCAN(X(I10),X(I20),X(I30),X(I41),X(I50),IA,L0,L1,L3,L1)
      IF(OUT) WRITE(IW,8888)
      IF(OUT) CALL PREVL(X(I30),X(I41),L0,L1,L1)
C
      IPASS=1
      NDAF=15
  100 CONTINUE
      CALL GSSRD(X(I30),X(I20),X(I41),L1,L2,L3,NDAF)
C
C     ----- ASSIGN A SYMMETRY REPRESENTATION LABEL TO MO'S -----
C
      CALL DAREAD(IDAF,IODA,X(I50),L2,12)
      CALL DAREAD(IDAF,IODA,X(I10),L3,13)
      CALL SYMMOS(X(I50),X(I50),X(I50),X(I10),X(I50),X(I30),X(I21),
     1            IA,L0,L1,L0,L1)
      IF(IPASS.EQ.1.AND.NOC.GT.0)
     1 CALL GSSOUT(X(I30),X(I41),X(I50),NOC,L1,L1)
      IF(IPASS.EQ.2) GO TO 200
      IPASS=2
      NDAF=19
      GO TO 100
  200 CONTINUE
C
C     ----- RESET CORE MEMORY -----
C
      CALL CMEM(NGOTCM)
      IF(NGOTCM.NE.LOADCM) CALL SETC(LOADCM)
      RETURN
 9999 FORMAT(/,' MOLECULAR ORBITALS READ FROM SAVED FILE',/)
 8889 FORMAT(/,1X,'OVERLAP MATRIX',/,1X,14(1H-))
 8888 FORMAT(/,1X,'CANONICAL ORTHONORMAL ORBITALS',/,1X,30(1H-))
      END
      SUBROUTINE GSSPUN(NOC)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (MXIODA=255)
      PARAMETER (MXATOM=128)
      COMMON/INFOA/NAT,ICH,MUL,NUM,NX,NE,NA,NB,ZAN(MXATOM),
     1                                         C(3,MXATOM)
      COMMON/IOFILE/IR,IW,IP
      COMMON/DAFILE/IDAF,NAV,IODA(MXIODA)
      COMMON/SCM/X(1)
      DATA VECWRD,ENDWRD /8H $VEC   ,8H $END   /
C
      L1= NUM
      L2=(NUM*(NUM+1))/2
      L3= NUM*NUM
C
C     ----- SET POINTERS FOR PARTITIONING OF CORE -----
C
      I10=     1
      I20=I10+L2
      I30=I20+L3
      I40=I30+L1
C
C     ----- GET CORE MEMORY -----
C
      CALL CMEM(LOADCM)
      LAST=I40-1
      LOC10=LOCCM(X(I10))
      NEED=LOC10+LAST
      CALL SETC(NEED)
C
      IPASS=1
      NDAF=15
  100 CONTINUE
      CALL GSSRD(X(I20),X(I10),X(I30),L1,L2,L3,NDAF)
      WRITE(IP,9999)
      IF(NOC.GT.0) WRITE(IP,9998) VECWRD
      IF(NOC.GT.0) CALL PUSQL(X(I20),NOC,L1,L1)
      IF(NOC.GT.0) WRITE(IP,9998) ENDWRD
      IF(IPASS.EQ.2) GO TO 200
      IPASS=2
      NDAF=19
      GO TO 100
  200 CONTINUE
C
C     ----- RESET CORE MEMORY -----
C
      CALL CMEM(NGOTCM)
      IF(NGOTCM.NE.LOADCM) CALL SETC(LOADCM)
      RETURN
 9999 FORMAT('   --- VECTORS FROM -GSSPUN- ---')
 9998 FORMAT(A8)
      END
