CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     HONDO : HND FORTRAN
C           : PORTABLE VERSION BY Y. VOLOBUEV AND J. THOMPSON JUNE 2001
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      PROGRAM HND95
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/MEMORY/MAXCOR,MAXLCM
C
C --- SGI MEMORY --                                                     !JT0601
C  
C     COMMON/SCM/XS( 7000000)
      COMMON/SCM/XS( 9000000)
      COMMON/LCM/XL(       1)
C     DATA MEMSCM  / 7000000/
      DATA MEMSCM  / 9000000/
      DATA MEMLCM  /       1/
      MAXCOR=MEMSCM
      MAXLCM=MEMLCM

c
c     ----- xlf 3.x runtime options -----
C     -----    FOR IBM PLATFORM     -----
c
C     call setrteopts('namelist=old:xrf_messages=yes:err_recovery=yes')
c
      CALL HONDO
      END
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     SYSTEM DEPENDENT ROUTINES:
C                               FROM vec.f ......
C                               FROM aix.f       |
C                               FROM mq2.f       |----> VERSION 3.2
C                               FROM  io.f ......|
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C --- FILES FROM vec.f ---                                              !JT0601
C
      SUBROUTINE DIAGIV(A,VEC,EIG,IA,NVEC,N,NDIM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C     ----- GENERAL CALLING  ROUTINE FOR -DIAGONALIZATION- -----
C
      CHARACTER*8 ERRMSG
      COMMON/IOFILE/IR,IW
      COMMON/MEMVEC/IADVEC,MAXVEC
      COMMON/SCM/XV(1)
      DIMENSION A(1),VEC(NDIM,1),EIG(1),IA(1)
      DIMENSION ERRMSG(3)
      DATA ERRMSG /'PROGRAM ','STOP IN ','-DIAGIV-'/
C
      I10=1+IADVEC
      I20=I10+(N*(N+1))/2
      I30=I20+ N
      I40=I30+ N* N
      I50=I40+ N* 9
      LAST=I50-1
      NEED=LAST-IADVEC
      IF(NEED.GT.MAXVEC) THEN
         WRITE(IW,9999) NEED
         CALL HNDERR(3,ERRMSG)
      ENDIF
C
      DO I=1,N
         DO J=1,I
            IJ=I+((N+N-J)*(J-1))/2
            XV(IJ+I10-1)=A(IA(I)+J)
         ENDDO
      ENDDO
C
      IF(NVEC.EQ.N) THEN
C
C --- FOR SGI ---                                                       !JT0601
C
C        CALL DSPEV(1,XV(I10),XV(I20),XV(I30),N,N,     XV(I40),2*N)
         CALL DSPEV('V','L', N, XV(I10),XV(I20), XV(I30),N,
     &      XV(I40), info)
      ELSE
C
C --- FOR SGI ---                                                       !JT0601
C
C        CALL DSPEV(1,XV(I10),XV(I20),XV(I30),N,N,     XV(I40),2*N)
C....    CALL DSPSV(1,XV(I10),XV(I20),XV(I30),N,N,NVEC,XV(I40),9*N)
         CALL DSPEV('V','L', N, XV(I10),XV(I20), XV(I30),N,
     &      XV(I40), info)
      ENDIF
C
      DO J=1,NVEC
         EIG(J)=XV(J+I20-1)
         DO I=1,N
            VEC(I,J)=XV(I+(J-1)*N+I30-1)
         ENDDO
      ENDDO
      RETURN
 9999 FORMAT(' IN -DIAGIV- , NOT ENOUGH SCRATCH SPACE FOR VECTOR.',
     1       ' NEEDED = ',I10)
      END
C
C --- FILES FROM sys.f ---                                              !JT0601
C
      SUBROUTINE SYSCLK(DIAL)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (TEN3=1.0D+03)
C
C     ----- -CPU- AND -WALL- TIME -----
C
C     DIAL(1) = DATE
C     DIAL(2) = TIME
C     DIAL(3) = CPUSEC
C     DIAL(4) = TOTSEC
C     DIAL(5) = DELCPU
C     DIAL(6) = DELTOT
C
      DIMENSION DIAL(6)
C
C --- FOR SGI ---                                                       !JT0601
C
C     REAL*4 CPUTIM,ETIME_
C     TYPE TB_TYPE
C        SEQUENCE
C        REAL*4 USRTIM
C        REAL*4 SYSTIM
C     END TYPE
C     TYPE (TB_TYPE) ETIME_STRUCT
C     CPUTIM =ETIME_(ETIME_STRUCT)
      REAL*4 CPUTIM,ETIME
C     REAL*4:: TARRAY(2)
      REAL*4 TARRAY
      DIMENSION TARRAY(2)
      CPUTIM = ETIME(TARRAY)
      DIAL(3)=CPUTIM
C     TOTTIM =TIMEF()/TEN3
      TOTTIME=TIME()/TEN3
      DIAL(4)=TOTTIM
      RETURN
      END

      SUBROUTINE SYSTIM(HOUR)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*8  HOUR
C
C --- FOR SGI ---                                                       !JT0601
C
C     CHARACTER*8  CLOCK_
C     HOUR=CLOCK_()
C     CHARACTER*8  CLOCK
C     HOUR=CLOCK()
      Call Time(HOUR)
      RETURN
      END
      SUBROUTINE SYSDAT(DAY)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*9  DAY
C     CHARACTER*8  DATE
C     DAY=DATE()
      CALL DATE(DAY)
      RETURN
      END
C
C --- FILES FROM io.f ---                                               !JT0601
C
      SUBROUTINE FIFLSH(NFT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C --- FOR SGI ---                                                       !JT0601
C
C     CALL FLUSH_(NFT)
      CALL FLUSH(NFT)
      RETURN
      END
C
C --- FILES FROM mq2.f ---                                              !JT0601
C
      SUBROUTINE MQFLSH(LUNFLS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C --- FOR SGI ---                                                       !JT0601
C
C     call FLUSH_(LUNFLS)
      call FLUSH(LUNFLS)
      RETURN
      END

